<%@ ENABLESESSIONSTATE=True%>
<%
Option Explicit
Response.Buffer = True
On Error Resume Next

Const CHUNK_SIZE							= 10240

'***********************************************************************
' Name:    getParamVal
' Purpose: returns Response Params ,  post and get http requests
'***********************************************************************
Function getParamVal(paramName,defaultValue)
	getParamVal = getParamValEx(paramName, defaultValue, Null)
End Function

Function getParamValEx(paramName, defaultValue, regex)
	Dim paramValue
	paramValue = ""

	If Not IsEmpty(Request.Form(paramName)) Then
		paramValue = Request.Form(paramName)
		if Not IsNull(regex) then
			if regex.Test(paramValue) = False then
				getFormParamEx = defaultValue
				Exit Function
			end if
		end if
	Else
		paramValue = Request.QueryString(paramName)
		if IsEmpty(paramValue) or paramValue = "" then
			paramValue = defaultValue
		end if
	End If

	getParamValEx = paramValue
End Function

Sub HandleFileNotFoundError()
	Dim strLobbyURL, nLobbyURLLength
	strLobbyURL = CStr(Request.ServerVariables("HTTP_REFERER"))
	nLobbyURLLength = InStr(strLobbyURL, "/gcc/")
	If nLobbyURLLength = 0 Then
		Response.Status = "404 Not Found"
	Else
		strLobbyURL = Left(strLobbyURL, nLobbyURLLength + 4)
		strLobbyURL = strLobbyURL + "error.asp?error=-2&ba=" & nBillingAccountID
		Response.Redirect strLobbyURL
	End If
	Response.End
End Sub

Function IsFileExists(strFileURL)
	If IsNull(strFileURL) Or strFileURL = "" Then
		IsFileExists = False
	Else
		Dim oFileSystem
		Set oFileSystem = Server.CreateObject("Scripting.FileSystemObject")
		IsFileExists = oFileSystem.FileExists(Server.MapPath(strFileURL))
		Set oFileSystem = Nothing
	End If
End Function

Dim strFileName, strFileUrl
' Extract parameters
strFileName = getParamVal("filename", 0)
strFileUrl = getParamVal("url", "")

If Len(strFileUrl) < 10 Then
    Call HandleFileNotFoundError()
End If

If Not IsFileExists(strFileUrl) Or StrComp(Right(strFileUrl, 10), "cached.ppt") <> 0 Then
	Call HandleFileNotFoundError()
End If

Dim oBinaryStream
Set oBinaryStream = CreateObject("ADODB.Stream")
'Specify stream type - we want To save binary data.
oBinaryStream.Type = 1
oBinaryStream.Open()
oBinaryStream.LoadFromFile(Server.MapPath(strFileUrl))

Response.ContentType = "application/octet-stream"
Response.AddHeader "Content-Disposition", "attachment; filename=" & strFileName
Response.AddHeader "Content-Length", oBinaryStream.Size

While Not oBinaryStream.EOS
	Response.BinaryWrite oBinaryStream.Read(CHUNK_SIZE)
	Response.Flush
Wend

oBinaryStream.Close()
Set oBinaryStream = Nothing
Response.End
%>
