<!--#include virtual="/gcc_content/util/aspincludes.inc"-->
<%
On Error Resume Next


'
'*********************************************************
'
' Name:    readBinaryFile
'
' Purpose: Read Binary file
'
'
' Inputs:  full path of file
'
' Return:  If succeeded, return all Binary Data
'		   null if errors
'
'*********************************************************
Function readBinaryFile(strFilePath)

  On Error Resume Next
  Dim TypeBinary, oStream

  Set oStream = Server.CreateObject("ADODB.Stream")

  oStream.Open
  oStream.Type = 1   ' Indicates a binary file
  oStream.LoadFromFile strFilePath

  If Err <> 0 Then
  	getBinaryFile = Null
  Else
  	readBinaryFile = oStream.read
  End If

  Set oStream = Nothing
End Function

'*********************************************************
'
' Name:    validateFileName
'
' Purpose: Make sure the requested file is under current path,
'			and no relative path
'
'
' Inputs:  relative url path
'
' Return:  Full path of local file mapping if file valide
'		   null if file invalide
'
'*********************************************************
Function validateFileName(strFilePath)
	dim sCurPath
	dim sFileFullPath
	dim bRet
	dim iPos

	bRet = False

	If (Not IsEmpty(strFile)) AND strFile <> "" Then
		sCurPath = Server.MapPath(".")
		sFileFullPath =  Server.MapPath(strFilePath)
		iPos = InStr(1, sFileFullPath, sCurPath, 1)

		'sub-directories or files
		if iPos = 1 Then
			'check relative path
			iPos = InStr(1, sFileFullPath, "../", 1)
			if iPos < 1 Then
				bRet = True
			End If
		End If
	End If

	if bRet Then
		validateFileName = sFileFullPath
	else
		validateFileName = Null
	End If

End Function

'*********************************************************
'
' Name:    writeBinaryFile
'
' Purpose: Write Binary file to http client
'
'
' Inputs:  full path of file
'
' Return:  void
'
'*********************************************************
Sub writeBinaryFile(strFilePath)
	On Error Resume Next
	Response.buffer = true
	'Response.contenttype = "application/octet-stream"
	Response.BinaryWrite readBinaryFile(strFilePath)
End Sub

'*********************************************************
'
' Name:    Main
'
' Purpose: Return the file to http client indicated by querystring
'			parameter "Name"
'
'*********************************************************
Dim strFile
Dim sLocalFile
strFile = Request.querystring("Name")

sLocalFile = validateFileName(strFile)


If Not IsNull(sLocalFile) Then
	writeBinaryFile sLocalFile
Else
	'Response.Write "Wrong file"
End if

Response.End

%>
