// Global Property manager ...
function Property(n,v) { this.name=n;this.value=v; }

function propManag_getPropertyObject(p, name) {
	var pm=null;
    for (i=0;i<p.length;i++) {
    	if (p[i].name==name) pm=p[i];
    }
   	return pm;
}

function propManag_setProperty(p, name, val) {
    pm=propManag_getPropertyObject(p, name);
    if(pm) {
        if (val) pm.value=val;
        else pm.name="";
    }
    else if (val) { pm = new Property(name,val); p[p.length]=pm; }
}

function propManag_getProperty(p, name) {
    pm=propManag_getPropertyObject(p, name);
    if(pm) return pm.value; else return "";
}

var arrProperties = new Array;

// Convenient public API
function SetProperty(name, value) { propManag_setProperty(arrProperties, name, value); return 1;}
function GetProperty(name) { return propManag_getProperty(arrProperties, name);}
function RemoveProperty(name) { propManag_setProperty(arrProperties, name, null); return 1;}
function RemoveAllProperties() { arrProperties.length=0; return 1;}
