var slidecachesize = 0;
var slidecachedelay = 0;
var strTimerId = null;

var arrSlideNameLists;
var baseSlideUrl = "";

var currSlideName = "";
var currSlideIndex;//Start from 1, other components please don't set it's value.
var previousSlideName = "";
//Slide cache queue
var arrNamesOfCurrCachedSlides;
//Slide request cache queue
var arrNameOfNeedCachedSlides;

var currLoadingIdx;
var currLoadingSlideName;

var bIsBC = false;
//var bNeedDelay = true;
var bSingleResolution = false;
var bPlayer = false;
var strSizeDir="";

function loadScaleJS(strURL)
{
	var objScale = document.getElementById("scale");
	if (objScale)
		go();
	else
	{
		var _doc = document.getElementsByTagName('head')[0];
		var js = document.createElement("script");
		js.setAttribute("type", "text/javascript");
		js.setAttribute("src", strURL);
		js.setAttribute("id", "scale");
		_doc.insertBefore(js,_doc.lastChild);
		go();
	}
}

function go()
{
	if(bSingleResolution || window.getSizeDir)
	{
		arrNamesOfCurrCachedSlides = new Array(slidecachesize+2);	//Previous + Current + Next N
		arrNameOfNeedCachedSlides = new Array(slidecachesize+1);	//Current + Next N
		var i = slideUrl.lastIndexOf("/");
		var j = slideUrl.lastIndexOf(".html");
		if (!bSingleResolution)
			strSizeDir = getSizeDir();
		createCachedFrame(slidecachesize+2);
		setCurrentSlide(slideUrl.substring(i+1, j+5));
	}
	else
		setTimeout("go();", 100);//wait until scale.js is loaded.
}

function resizeCalled()
{
	if(!bSingleResolution)
	{
		if (getSizeDir() != strSizeDir)
		{
			strSizeDir = getSizeDir();
			setCurrentSlide(currSlideName);
		}
	}
}

function getCurrentSlideWidth()
{
	var sclWidth = 0;
	var frameObj;
	if (top.currSlideIndex)
	{
		frameObj = top.frames["slideframe" + top.currSlideIndex];
		if (frameObj)
		{
			if(frameObj.SCL)
			{
				sclWidth = frameObj.SCL.style.pixelWidth;
			}
		}
	}
	return sclWidth;
}

function calcColsProp(nNumOfFrame, currentSlideIndex)
{
	var strColsProp="";
	for (var i = 1; i <= nNumOfFrame; i++)
	{
		if (currentSlideIndex == i)
			strColsProp += "*";
		else
			strColsProp += "0";
		if (i != nNumOfFrame)
			strColsProp += ","
	}
	return strColsProp;
}

// Show current slide in cached frames
function setColsProp(strColumnProperty)
{
	var parentFrameSet;
	parentFrameSet = document.getElementById("masterFrameset");
	parentFrameSet.cols = strColumnProperty;
}

function createCachedFrame(nNumber)
{
	var i;
	var newFrame,parentFrameSet;
	parentFrameSet = document.getElementById("masterFrameset");
	var frameContent, strCols;
	for (i = nNumber; i >= 1; i--)
	{
		newFrame = document.createElement("frame");
		newFrame.id = "slideframe" + i;
		newFrame.name = "slideframe" + i;
		newFrame.src = "blank.html";
		
		if(i == nNumber)
			parentFrameSet.cols += "*";
		else
			parentFrameSet.cols += ",0";
		parentFrameSet.insertBefore(newFrame, parentFrameSet.firstChild);
	}
}

function setCurrentSlide(currentSlideName)
{
	if(bSingleResolution || window.getSizeDir)
	{
		if(currentSlideName.indexOf(".html?") > 0)
		{
			currentSlideName = currentSlideName.substring(0,currentSlideName.indexOf(".html?")+5);
		}
		
		if (currSlideName != currentSlideName)
			setPreviousSlide(currSlideName);
		currSlideName = currentSlideName;
		arrNameOfNeedCachedSlides[0] = currSlideName;
		var frameObj;
		if (arrSlideNameLists && arrSlideNameLists.length > 0)
		{
			setNextSlides(currSlideName,slidecachesize);
			
			var i,j;
			var bCached = false;
			var strCacheURL
			var strCacheSize = "";
			for(i = 0; i < arrNamesOfCurrCachedSlides.length; i++)
			{
				if (currentSlideName == arrNamesOfCurrCachedSlides[i])
				{
					if (bSingleResolution)
						bCached = true;
					else
					{
						frameObj = document.getElementById("slideframe" + (i+1));
														
						if (frameObj)
						{
							if(frameObj.frameElement)
								strCacheURL = frameObj.frameElement.src;
							else
							{
								if (frameObj.src)
									strCacheURL = frameObj.src;
							}
							
							
						}
						j = strCacheURL.lastIndexOf("/");
						strCacheURL = strCacheURL.substring(0,j);
						j = strCacheURL.lastIndexOf("/");
						strCachedSize = strCacheURL.substr(j+1);
						if (strCachedSize == strSizeDir)
							bCached = true;
					}
					break;
				}
			}
			if (bCached)
			{
				frameObj = document.getElementById("slideframe" + (i+1));
				
				if (frameObj)
				{
		            var strCols = calcColsProp(slidecachesize+2, i+1);
		            setColsProp(strCols);
					if(frameObj.frameElement)
						slideLoaded(frameObj.frameElement);
					else
					{
						if (frameObj.src)
							slideLoaded(frameObj);
					}
					currSlideIndex = i+1;
				}
			}
			else
			{
				var bNeedKept;
				var m,l;
				var bFoundVacancy = false;
				if (arrNamesOfCurrCachedSlides)
				{
					for(m = 0; m < arrNamesOfCurrCachedSlides.length; m++)
					{
						if (arrNamesOfCurrCachedSlides[m] == null || arrNamesOfCurrCachedSlides[m] == "")
						{
							bFoundVacancy = true;
							break;
						}
					}
				}
				
				if(!bFoundVacancy)
				{
					for(m = 0; m < arrNamesOfCurrCachedSlides.length; m++)
					{
						if (!bSingleResolution)
						{
							frameObj = document.getElementById("slideframe" + (m+1));
							if (frameObj)
							{
								if(frameObj.frameElement)
									strCacheURL = frameObj.frameElement.src;
								else
								{
									if (frameObj.src)
										strCacheURL = frameObj.src;
								}
								
								j = strCacheURL.lastIndexOf("/");
								strCacheURL = strCacheURL.substring(0,j);
								j = strCacheURL.lastIndexOf("/");
								strCachedSize = strCacheURL.substr(j+1);
							}
						}
										
						bNeedKept = false;
						if (arrNamesOfCurrCachedSlides[m] == previousSlideName)
						{
							bNeedKept = true;
						}
						else
						{
							for(l = 0; l < arrNameOfNeedCachedSlides.length; l++)
							{
								if (arrNamesOfCurrCachedSlides[m] == arrNameOfNeedCachedSlides[l])
								{
									if (bSingleResolution)
										bNeedKept = true;
									else if (strCachedSize == strSizeDir)
										bNeedKept = true;
									break;
								}
							}
						}
						if (!bNeedKept) break;
					}
				}
							
				if (m < arrNamesOfCurrCachedSlides.length && currentSlideName != "")
				{
					currLoadingIdx = m+1;
					currSlideIndex = m+1;
					currLoadingSlideName = currentSlideName;
		            var strCols = calcColsProp(slidecachesize+2, currSlideIndex);
		            setColsProp(strCols);
					loadSlide();
				}
				else
				{
					currLoadingIdx = -1;
					currLoadingSlideName = "";
				}			
			}	
		}
		else{
			currLoadingIdx = 1;
			currSlideIndex = 1;
			currLoadingSlideName = currentSlideName;
            var strCols = calcColsProp(slidecachesize+2, currSlideIndex);
			currLoadingSlideName = currentSlideName;
			loadSlide();
		}
	
		if(parent && parent.ConfSendEvent)
		{
			frameObj = document.getElementById("slideframe" + currSlideIndex);
			if (frameObj)
			{
				if(frameObj.frameElement)
					parent.ConfSendEvent(1,frameObj.frameElement.src,frameObj.frameElement.id,1,0,0);
				else
				{
					if (frameObj.src)
						parent.ConfSendEvent(1,frameObj.src,frameObj.id,1,0,0);
				}
			}
		}
	}
	else
		loadScaleJS(baseSlideUrl + "scale.js");
}

function loadSlide()
{
	var frame = document.getElementById("slideframe" + currLoadingIdx);
	if (frame)
	{
		var slideUrl = baseSlideUrl;
		if (bSingleResolution)
			slideUrl += currLoadingSlideName;
		else
			slideUrl += (strSizeDir + "/" + currLoadingSlideName);		
		if (bIsBC)
		{
			slideUrl += '?BC=1';
			if (bPlayer)
				slideUrl += '&Player=1';
		}
		frame.src = slideUrl;
	}
}

function setSlideStatus(index, strSlideName)
{
	if (index <= arrNamesOfCurrCachedSlides.length)
	{
		arrNamesOfCurrCachedSlides[index - 1] = strSlideName;
	}
}

function getNextSlide(currSlideName)
{
	if (arrNameOfNeedCachedSlides && arrNameOfNeedCachedSlides.length > 0)
	{
		var i, strReturn = "";
		for (i = 0; i < arrNameOfNeedCachedSlides.length; i ++)
		{
			if (arrNameOfNeedCachedSlides[i] == currSlideName)
				break;
		}
		if (i < arrNameOfNeedCachedSlides.length - 1)
			strReturn = arrNameOfNeedCachedSlides[i+1];
		return strReturn;
	}
}

function getPreviousSlide()
{
	return previousSlideName;
}

function setPreviousSlide(currSlideName)
{
	//According to the order of navigation.
	previousSlideName = currSlideName;
}

function setNextSlides(currSlideName, nSlideCacheNumber)
{
	if (arrSlideNameLists && arrSlideNameLists.length > 0)
	{
		var i,j;
		for (i = 0; i < arrSlideNameLists.length; i ++)
		{
			if (arrSlideNameLists[i] == currSlideName)
				break;
		}
		j = 1;
		while (i + j <= arrSlideNameLists.length - 1 && j <= nSlideCacheNumber)
		{
			arrNameOfNeedCachedSlides[j] = arrSlideNameLists[i + j];
			j++;
		}
	}
}

// Check if we need preloading after current slide is loaded.
function slideLoaded(srcFrame)
{
	var frameName = srcFrame.name;
	var strSlideName = "";
	var strNextSlideName = "";	
		
	var i,j;
	if(srcFrame.src)
	{
		if (srcFrame.src == "blank.html" || srcFrame.src == "") return;
		i = srcFrame.src.lastIndexOf("/");
		j = srcFrame.src.indexOf("?BC=");
		if (i > 0 && i < srcFrame.src.length)
		{
			if (j > 0 && j > i)
				strSlideName = srcFrame.src.substring(i+1,j);
			else
				strSlideName = srcFrame.src.substr(i+1);
		}
	}
	
	if (strSlideName != "")
	{
		setSlideStatus(frameName.substr(10), strSlideName);
	}
	
	if (strSlideName == currSlideName)
	{
		setNextSlides(currSlideName,slidecachesize);
		//setPreviousSlide(currSlideName);
		/*
		nCurrIndex = frameName.substr(10);
		var strCols = calcColsProp(slidecachesize+2, nCurrIndex);
		setColsProp(strCols);
		*/
	}
	
	strNextSlideName = getNextSlide(strSlideName);
	if (strNextSlideName != "")
	{
		var bCached;
		
		do
		{
			bCached = false;
			for(i = 0; i < arrNamesOfCurrCachedSlides.length; i++)
			{
				if (strNextSlideName == arrNamesOfCurrCachedSlides[i])
				{
					bCached = true;
					strNextSlideName = getNextSlide(strNextSlideName);
					break;
				}
			}				
		} while (bCached && strNextSlideName != "")
		var bNeedKept;
		var m,l;
		if (strNextSlideName !="")
		{
			for(m = 0; m < arrNamesOfCurrCachedSlides.length; m++)
			{
				if (arrNamesOfCurrCachedSlides[m] == null || arrNamesOfCurrCachedSlides[m] == "")
					break;
				else
				{
					bNeedKept = false;
					
					if (previousSlideName != null && previousSlideName != "" && arrNamesOfCurrCachedSlides[m] == previousSlideName)
					{
						bNeedKept = true;
					}
					else
					{
						for(l = 0; l < arrNameOfNeedCachedSlides.length; l++)
						{
							if (arrNamesOfCurrCachedSlides[m] == arrNameOfNeedCachedSlides[l])
							{
								bNeedKept = true;
								break;
							}
						}
						if (!bNeedKept) break;
					}
				}
			}
			if (m < arrNamesOfCurrCachedSlides.length && strNextSlideName != "")
			{
				currLoadingIdx = m+1;
				currLoadingSlideName = strNextSlideName;
				if (/*bNeedDelay && */slidecachedelay != 0)
				{
					//bNeedDelay = false;
					strTimerId = setTimeout("loadSlide();", slidecachedelay);
					slidecachedelay = 0;
				}
				else
					loadSlide();
			}
			else
			{
				currLoadingIdx = -1;
				currLoadingSlideName = "";
			}
		}
	}
	
}

function setSlideLists(strSlideNames)
{
	if (arrSlideNameLists == null || arrSlideNameLists.length == 0)
	{
		arrSlideNameLists = strSlideNames.split(";");
	}
}

function getHttpRequest()
{
    if ( window.XMLHttpRequest ) // Gecko
		return new XMLHttpRequest();
    else if ( window.ActiveXObject ) // IE
		return new ActiveXObject("MsXml2.XmlHttp");
	else
		alert("Error, can't create a XmlHttpRequest object!");
}

function IsExist(url)
{
	var objXmlHttpRequest;
	var bResult = false;
	objXmlHttpRequest = getHttpRequest();
	if (objXmlHttpRequest)
	{
		objXmlHttpRequest.open("HEAD",url,false);
		objXmlHttpRequest.send(null);
		if (objXmlHttpRequest.status == 200 || (objXmlHttpRequest.status == 0 && bPlayer == true))
			bResult = true;
		delete objXmlHttpRequest;
	}
	return bResult;
}