<!--#include virtual="/gcc_content/util/aspincludes.inc"-->
<%
Response.Write GetFileList(Server.MapPath("."))
Response.End


Dim g_fso
Dim g_nFileCnt
Dim g_nPathCnt  'including itself, so at least 1
Dim g_sBuffer
Dim g_tLastModified
Dim g_sLastModified
'Dim chr(13) & chr(10)
'Const chr(13) & chr(10) = "<BR>"



Function  GetFileList(folderspec)
	g_nFileCnt = 0
	g_nPathCnt = 0
	g_sBuffer = ""
	g_sLastModified = "10/18/1970 11:48:38 AM"
	g_tLastModified = CDate(g_sLastModified)


	Set g_fso = CreateObject("Scripting.FileSystemObject")

	ShowFolderList folderspec, folderspec

	g_sBuffer = "[HDR]" & chr(13) & chr(10) _
				& "SCODE=0" & chr(13) & chr(10) _
			  & "PATH_COUNT=" & g_nPathCnt & chr(13) & chr(10) _
			  & "FILE_COUNT=" & g_nFileCnt & chr(13) & chr(10) _
			  & "LASTMODIFIED=" & g_sLastModified & chr(13) & chr(10) _
		  	  & g_sBuffer

	Set g_fso = Nothing

	GetFileList = g_sBuffer
End Function

Sub ShowFolderList(folderspec, sRootPath)
   Dim  folderItem, folderCollection, folder
   Dim sFolderName
   Set folder = g_fso.GetFolder(folderspec)
   Set folderCollection = folder.SubFolders


   ShowFilesList folderspec, sRootPath

   if folderCollection.Count > 0 Then
	   For Each folderItem in folderCollection
		  sFolderName = folderspec & "\" & folderItem.name
		  ShowFolderList sFolderName, sRootPath
	   Next
   End If


  Set folder = Nothing
  Set folderCollection = Nothing

End Sub


Sub Trace(Msg)
	'if verbose = true then
		'WScript.Echo Now & " : " & Msg
		WScript.Echo Msg
	'end if
End Sub

Sub ShowFilesList(folderspec, sRootPath)

	Dim fileItem, fileCollection
	Dim folder
	Dim sFileName
	Dim iSubPathFileCnt
	iSubPathFileCnt = 0

	Set folder = g_fso.GetFolder(folderspec)
	Set fileCollection = folder.Files


	FormatPathOutput folderspec, sRootPath, folder


	For Each fileItem in fileCollection

		sFileName = folderspec & "\" & fileItem.name
		iSubPathFileCnt = iSubPathFileCnt+ 1
		FormatFileOutput sFileName, sRootPath, fileItem, iSubPathFileCnt
	Next

	Set folder = Nothing
	Set fileCollection = Nothing

End Sub

Sub FormatPathOutput(folderspec, sRootPath, folderItem)
	Dim sLastModified
	sLastModified = folderItem.DateLastModified
	CompareLastModify(sLastModified)

	g_nPathCnt = g_nPathCnt + 1
	g_sBuffer = g_sBuffer  _
			& "[PATH_" & g_nPathCnt & "]" & chr(13) & chr(10) _
			& "PATH" & "=" & Mid(folderspec, Len(sRootPath) + 2)  & chr(13) & chr(10) _
			& "PATH_LASTMODIFIED" & "=" & sLastModified & chr(13) & chr(10)
End Sub

Sub FormatFileOutput(sFileName, sRootPath, fileItem, iSubPathFileCnt)
	Dim sLastModified
	sLastModified = fileItem.DateLastModified
	CompareLastModify(sLastModified)

	g_nFileCnt = g_nFileCnt + 1
	g_sBuffer = g_sBuffer _
			& "FILE_" & iSubPathFileCnt & "=" & Mid(sFileName, Len(sRootPath) + 2)  & chr(13) & chr(10) _
			& "FILE_LASTMODIFIED_" & iSubPathFileCnt & "=" & sLastModified & chr(13) & chr(10)
End Sub

Sub CompareLastModify(sNewLastModified)
	Dim iNewLastModified
	iNewLastModified = CDate(sNewLastModified)

	'Trace DateDiff("s" , g_tLastModified, iNewLastModified)
	if DateDiff("s" , g_tLastModified, iNewLastModified) > 0 Then
		g_tLastModified = iNewLastModified
		g_sLastModified = sNewLastModified
	End If
End sub
%>
