var browserName = navigator.appName.toLowerCase();
var bIsNS = (browserName.indexOf("netscape") != -1);
var bIsIE = (browserName.indexOf("internet") != -1);

var wndInstallerTester = null;
var installerURL;
var preload4URL;
initURLs();

function launchInstallerWnd(installerURL)
{	
	var sLeft = screen.Width;
	var sTop = screen.Height;

	wndInstallerTester = window.open(installerURL, "WND_ACTIVEX_TEST","toolbar=0,location=0,directories=0,status=1,menubar=0,scrollbars=no,resizable=0,width=100,height=100,left=" + sLeft + ",top=" + sTop);
	if (wndInstallerTester)
	{
		wndInstallerTester.opener = window;
		wndInstallerTester.focus();
	}
	else  //in some case, we can't pop up windows in, block pop mode
		onInstallerTestDone(true);
		
	setTimeout("waitInstallerPageOpened()", 300); 
}

function initURLs()
{
	var i = location.href.indexOf(location.pathname);
	var j = location.pathname.lastIndexOf("/");
	var sRoot = location.href.substring(0, i + j + 1);
	installerURL = sRoot + "installer.html";
	preload4URL = sRoot + "preload4_1.asp";

}

var bInstallerPageNotifyOpen = false;
var bInstallerPageOpen = false;

function onNotifyInstallerPageOpened()
{
	bInstallerPageNotifyOpen = true;
}

var bInstallerPageNotifyDone = false;
var bInstallerEnable = true;
function onNotifyInstallerPageDone(bEnable)
{
	bInstallerPageNotifyDone = true;
	bInstallerEnable = bEnable;
}

var iWaitPageOpenLoop = 0;
var iMaxWaitPageOpenCnt = 10000 / 200; //max wait 10 sec
var iWaitPageCnt = 0;
function waitInstallerPageOpened()
{
	if (!bInstallerPageNotifyOpen)
	{
		if (wndInstallerTester)
		{
			var bChildClosed = wndInstallerTester.closed;
			if ( bChildClosed || !isInstallerPageExist())
			{
				if (!bChildClosed)
					bInstallerPageOpen = true;
				
				if (bChildClosed && bInstallerPageOpen)//manually closed by user, 
					onNotifyInstallerPageDone(false);
				else
				{				
					//maybe window not opened or not loaded yet
					iWaitPageCnt = iWaitPageCnt + 1; 
					if (iWaitPageCnt < iMaxWaitPageOpenCnt)
					{
						setTimeout("waitInstallerPageOpened()", 200);
						return;
					}
					else
						onNotifyInstallerPageDone(false);
				}
			}
			else
			{
				iWaitPageCnt = iMaxWaitPageOpenCnt;
				setTimeout("waitInstallerPageOpened()", 200);
				return;
			}
		}
	}
	
	waitInstallerTestDone();
	
}

function waitInstallerTestDone()
{
	if ( !bInstallerPageNotifyDone)
	{
		if (wndInstallerTester)
		{
			if (!wndInstallerTester.closed)  //supposed we have wait enough in waitInstallerPageOpened()
			{
				if (isInstallerPageExist())//our page still there
				{
					setTimeout("waitInstallerTestDone()", 200);
					return;
				}
				else
				{
					onNotifyInstallerPageDone(false);	
				}
			}
			else
			{  
				onNotifyInstallerPageDone(false);
			}
		}
	}
	
	if (wndInstallerTester && !wndInstallerTester.closed)
	{
		wndInstallerTester.close();
		wndInstallerTester = null;
	}
	
	onInstallerTestDone(isInstallerEnabled());
}
function isInstallerPageExist()
{
	var sType = typeof(wndInstallerTester.isInitDone);
	sType.toLowerCase();
	return (sType.indexOf("unknown") == -1) && (sType.indexOf("undefined") == -1);
}

function isInstallerEnabled()
{
	return bInstallerEnable;
}
