/* File used by gcc_content/presentations (first_slide_proxy.html), or files not including params.js
	 Domain functions added and called here
	 !! Browser functions cannot be called from params.js !! */

// NEW VERSION FOR 4.0 CROSS BROWSERS SUPPORT and Browser Client specific processing


function getParent() {
    var p = window.parent;
    if (p && p == window) p = null;
    return p;
}

function Param(n,v) { this.name=n;this.value=v; }

function sToParams(s,p) {
    p.length=0;
    if(!s||s=="") return;
    var i=s.indexOf("?")+1;
    if (i<=0) return;
    var j;
    var bDone=false;
    while (!bDone) {
        j=s.indexOf("&",i); if(j<0) {j=s.length; bDone=true;}
        str=s.substring(i,j);
        k=str.indexOf("="); if(k<0) k=str.length-1;
        pm=new Param(unescape(str.substring(0,k)), unescape(str.substring(k+1,str.length)));
        p[p.length]=pm;
        i=j+1;
    }
}

function paramsToS(p) {
    var s="?";
	var bFirst=true;
    for(var i=0;i<p.length;i++)
        if (p[i].name!="") { s+=(bFirst?"":"&")+escape(p[i].name)+"="+escape(p[i].value); bFirst=false;}
	return (s=="?")?"":s;
}

function getPm(p,name) {
	var pm=null;
    for(var i=0;i<p.length;i++) {
    	if (p[i].name==name) pm=p[i];
    }
   	return pm;
}

function getParam(p,name) {
    pm=getPm(p,name);
    return (pm?pm.value:"");
}

function setParam(p,name,val) {
    pm=getPm(p,name);
    if(pm) {
        if (val) pm.value=val;
        else pm.name="";
    }
    else if (val) { pm = new Param(name,val); p[p.length]=pm; }
}

var searchParams = new Array;
var sQueryString = "";
try {
    if(!isSafari() && parent)
      sQueryString = parent.location.search;
    else
      sQueryString = location.search;
    }
catch(err) {
      sQueryString = location.search;
    }
sToParams(sQueryString, searchParams);
var strBC = getParam(searchParams, "BC");
strBC = strBC.substring(0,1);
var bIsBC = (strBC == "1" || strBC == "t");

var strPlayer = getParam(searchParams, "player");
strPlayer = strPlayer.substring(0,1);
var bPlayer = (strPlayer == "1");

if(bIsBC && !bPlayer)
{
  // code to set document.domain
  var h = document.location.hostname;
  var defdom = document.domain;
  var checkDomain = 2;

  var urlinfo = h.split(".");
  var l = urlinfo.length;i=1;dom="";
  if(l >= (checkDomain+1))
  	{
  	while(((l-i) >0) && (i <= checkDomain))
  		{
  		dom = "." + urlinfo[l-i] + dom;
  		i++;
  		}
  	}
  if(dom && dom != "")
  	{
  	dom = dom.substring(1,dom.length);
  	document.domain = dom;
  	}
}	

  // call a function to indicate that the presentation is loaded, maybe annotations needs to be displayed again
function setPresWidth(srcFrame) {

  if (!bIsBC) return;
  var fcontrol = top.frames['control'];
  if (fcontrol && fcontrol.gDisplay && fcontrol.gDisplay.presLoaded) {
    var testDiv = null, w = 0, h = 0, fcontent = null;
    if(!bPlayer) fcontent = srcFrame.contentWindow;
	else {
    	if (top.frames['content'] && top.frames['content'].contfrm && top.frames['content'].contfrm.slideframe && top.frames['content'].contfrm.slideframe.document) fcontent = top.frames['content'].contfrm.slideframe;
		}
    if (fcontent) {
      // get presentation value: nSlideWidth=(document.all.SCL)?document.all.SCL.style.pixelWidth:0;
      if(fcontent.document.getElementById)
        testDiv = fcontent.document.getElementById("SCL");
      else if (fcontent.document.all)
        testDiv = fcontent.document.all.SCL;
      else if(fcontent.document.layers)
        testDiv = fcontent.document.layers["SCL"];
    }
  // if in an html file: <div id="iDiv" style="width:1000px"></div>
  // alert("iDiv: " + iDiv.style.width + ", " + iDiv.style.pixelWidth + ", " + iDiv.clientWidth + ", " + iDiv.offsetWidth);
  // Result   :   | iDiv.style.width | iDiv.style.pixelWidth | iDiv.clientWidth | iDiv.offsetWidth
  // ---------------------------------------------------------------------------------------------
  // IE6          | 1000px           | 1000                  | 1000             | 1000
  // Opera9       | 1000px           | 1000                  | 1000             | 1000
  // Firefox      | 1000px           | undefined             | 1000             |    0
  // Safari 1.3   | 1000px           | 1000                  | 1000             | 1000
    if (testDiv) {w = testDiv.clientWidth; h = testDiv.clientHeight;}

    
 	if (fcontrol && fcontrol.gDisplay && fcontrol.gDisplay.presLoaded) fcontrol.gDisplay.presLoaded(w,h);
    ///Start of debug line added by Kevin
    //top.document.title = "Current presentation window width: " + w + ", height: " + h;
    ///End of debug line added by Kevin

  }
}

function isIE2()
{
	this.agent=navigator.userAgent;
	this.ver=navigator.appVersion;
	this.dom=document.getElementById?true:false;
	this.opera=this.agent.indexOf("Opera")>-1;
	this.ie5=(this.ver.indexOf("MSIE 5")>-1 && this.dom && !this.opera)?true:false; 
	this.ie6=(this.ver.indexOf("MSIE 6")>-1 && this.dom && !this.opera)?true:false;
	this.ie7=(this.ver.indexOf("MSIE 7")>-1 && this.dom && !this.opera)?true:false;
	this.ie4=(document.all && !this.dom && !this.opera)?true:false;
	this.bIe=this.ie4||this.ie5||this.ie6||this.ie7;
	return this.bIe;
}

if(!isIE2()) initVarJump();

RPGUID='clsid:CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA';
RPPARAMS='<PARAM NAME="CONTROLS" VALUE="ImageWindow">';
RPATTR='CONTROLS="ImageWindow"';
AMGUID='clsid:05589FA1-C356-11CE-BF01-00AA0055595A';
AMPARAMS='<PARAM NAME="ShowDisplay" VALUE="0"><PARAM NAME="ShowControls" VALUE="0"><PARAM NAME="ShowTracker" VALUE="0">';
AMATTR='AUTOSTART="FALSE" AUTOPLAY="FALSE" CONTROLLER="FALSE" SCALE="TOFIT" MASTERSOUND PLUGINSPAGE="http://www.apple.com/quicktime/download/"';
VIZ=0x0001;
MOVE=0x0002;
CLIP=0x0004;
MMSTRT=0x0008;
RPSTRT=0x0010;
IETRANS=0x0020;
PAUSE=0x0040;
ACTION=0x0080;
STARTTL=0x0100;
SIZE=0x0200;
MAXTM=32000;
BTN_TOGGLE=1;
BTN_EXCLUDE=2;
BTN_PUSH=0;
BTN_CHECK=BTN_TOGGLE;
BTN_RADIO=BTN_EXCLUDE;
SCORE_NONE=314159265;
INDEXMUL=1000
WAITINC=500;
MAXWAIT=30000;
TimeWarp=0.5;
NX="astrangenext";
RL="astrangelast";
AR="astafterrange";

//***** ALT BROWSERS SPECIFIC VARS *****
// set this var to true to enable jump.js debug console on all browsers but IE
var browserType ="";
var styleSupport=0;
var doTimeLineTimer, startTimeLineTimer;
var strStatus="";

// common vars
var bDoUnload = false;
var bSTr=false;
var AuthorDPI = 96;
var nextURL=null;
var nextURLTmp=null;
var nextURLTmpTarget=null;
var numDivs=0;
var bStarted=false;
var bPause=false;
var bStopped=false;
var nTimeIndex=0;
var nGlobalTime=0;
var nDur=0;
var nGTStep=100;
var nDelay=0;
var nSTT=0;
var nImgPct=100;
var bTimedPause=false;
var nPauseTime=0;
var bClickUnpause=true;
var nLoop=1;
var nMaxLoop=1;
var nTLoopStart=0;
var nLoopEnd=0;
var bDoingJump=false;
var strStatus="";
var loopCount = 0;
var nRestart=0;
var bCBTNeedLogin = false;
var nTryTime=0;
var bAdvOnClick=false;
var bDoUnload = false;
var cdfname = "default.cdf";
var RangeNext="";
var RangeLast="";
var AfterRange="";
var nOffsetTime=0;
var nOffsetPause=0;
var nOffsetOdo=0;
var bRestoreAnnot = false;
var bMaskOn=false;
var SlideScore=SCORE_NONE;
var startTime=0;
var realStartTime=0;
var curTime=0;
var parentFrame=null;
var bTimedSlide=true;
var strPageNm="";
var nQ=1;
var nQA=1;
var strNotesURL="";
var bDoSpeakerNotes=false;
var bNotesInWindow=true;
var notesW=null;
var nOdo=0;
var scFact=1.0;
var scFactAnnot=1.0;
var scFactFont=1.0;
var bReloadOnResize;
var bSlideLoaded = false;
var docW = 640;
var docH = 480;
var bDoAutoscale = false;
var bDoPickscale = false;
var bCheckScale = false;

if(isIE2())
	{
	bReloadOnResize = !isIE4;
	var Divs=new Array;
	document.tls=new Array;
	document.tls[0]=new Array;
	var MainTL = document.tls[0];
	MainTL.bActive = true;
	var pathArray=new Array;
	var	trIn=new Array;
	var	trOut=new Array;
	var params = new Array;
	var docbtns = new Array;
	docbtns.length = 0;
	}
else
	{
	var pathArray;
	var tls;
	var MainTL;
	var Divs;
	var trIn;
	var trOut;
	var params;
	var docbtns;
	bReloadOnResize = false;
	}




function getScaleFactor()
{
    var f1 = 1.0;
    var f2 = 1.0;
    if (window.innerWidth)
    {
        f1 = window.innerWidth / docW;
        f2 = window.innerHeight / docH;
    }
    else
    {
        f1 = document.body.clientWidth / docW;
        f2 = document.body.clientHeight / docH;
    }
    if (f2 < f1)
        f1 = f2;
    var scLevel = 1.0;
    if (f1 < 0.666667)
        scLevel = 0.5;
    else if (f1 < 0.75)
        scLevel = 0.666667;
    else if (f1 < 1.0)
        scLevel = 0.75;
    else if (f1 < 1.333333)
        scLevel = 1.0;
    else if (f1 < 1.5)
        scLevel = 1.333333;
    else if (f1 < 2.0)
        scLevel = 1.5;
    else
        scLevel = 2.0;
    return scLevel;
}

function getScaleAnnot(dW, dH)
{
    return dW/1000.0;
}

function setAutoscale(dW, dH)
{
    bDoAutoscale = true;
    docW = dW;
    docH = dH;
    scFact = getScaleFactor();
    getScale(AuthorDPI);	
}

function setPickscale(dW, dH)
{
bDoPickscale = true;
scFactAnnot = getScaleAnnot(dW, dH);
}

function getScale(dpi)
{
	AuthorDPI = parseInt(dpi);
	var brDPI=0;
	
	if (isIE2() == true)
	{
		if(isNS4)
			brDPI=document.layers['astDPIQuery'].clip.height;
		else if(isIE4)
			brDPI=document.all.astDPIQuery.style.pixelHeight;
	    if (brDPI<72)
	    	brDPI=96;
		scFactFont=dpi/brDPI*scFact;
		}
	else
	{
		var result=0, elt;
		elt=getElement('astDPIQuery', document);
		if (elt)
			{
			if (elt.offsetHeight) 
				{
				result = elt.offsetHeight;
		    } 
		  else if (elt.clip && elt.clip.height) 
		  	{
		    result = elt.clip.height;
		    } 
		  else if (elt.style && elt.style.pixelHeight) 
		  	{
		    result = elt.style.pixelHeight;
		    }
		  	brDPI=parseInt(result);
		  }
		
		if (brDPI<72)brDPI=96;
		scFactFont=dpi/brDPI*scFact;
	}
}

function stretchToFitClient(x,y){ }

function RPObj(id,url){
	if(isIE4)return '<OBJECT ID="'+id+'OBJ" CLASSID="'+RPGUID+'" HEIGHT=100% WIDTH=100%>'+RPPARAMS+'<PARAM NAME="SRC" VALUE="'+url+'"></OBJECT>';
	else return	'<EMBED NAME="'+id+'EMB" SRC="'+url+'" WIDTH=100% HEIGHT=100% '+RPATTR+'></EMBED>';
}

function QTObj(id,url,l){
        return '<EMBED NAME="'+id+'EMB" SRC="'+url+'"'+((l>1)?' LOOP="TRUE"':'')+' WIDTH=100% HEIGHT=100% '+AMATTR+'></EMBED>';
}

function AMObj(id,url,l){
	if(isIE4){
        s='<OBJECT ID="'+id+'OBJ" CLASSID="'+AMGUID+'" WIDTH=100% HEIGHT=100%>'+AMPARAMS+'<PARAM NAME="FileName" VALUE="'+url+'"><PARAM NAME="PlayCount" VALUE="'+l+'">';
        if(AMObj.arguments.length>3) s+='<PARAM NAME="MovieWindowWidth" VALUE="'+AMObj.arguments[3]+'"><PARAM NAME="MovieWindowHeight" VALUE="'+AMObj.arguments[4]+'">';
        return (s+'</OBJECT>');
    }
        return QTObj(id,url,l);
}

function ImObj(nm,src,w,h,alt,map){
	w=w*scFact;h=h*scFact;
	str='<IMG SRC="'+src+'" WIDTH="'+w+'" HEIGHT="'+h+'" BORDER="0" NAME="'+nm+'" ALT="'+alt+'"';
	if(map!=null&&map!="")str+=' USEMAP="#'+map+'"';
	str+='>';
	return str;
}

function TObj(FName,bFixed,nPtSize,color,nSt,nLS,text)
{
	if (isIE2() == true)
	{
		if((nSt&0x10)||(nSt&0x20))nPtSize=nPtSize*2/3;
		if(isNS4){
			var attr='FACE="'+FName+'" COLOR="#'+color+'" POINT-SIZE="'+(nPtSize*scFactFont)+'"';
			var str="<FONT "+attr+">";
			if(nSt&0x01)str+="<B>";
			if(nSt&0x02)str+="<I>";
			if(nSt&0x04)str+="<U>";
			if(nSt&0x10)str+="<SUP>";
			if(nSt&0x20)str+="<SUB>";
			str+=text;
			if(nSt&0x20)str+="</SUB>";
			if(nSt&0x10)str+="</SUP>";
			if(nSt&0x04)str+="</U>";
			if(nSt&0x02)str+="</I>";
			if(nSt&0x01)str+="</B>";
			str+="</FONT>";
			return str;
		}
		else{
			var style="font-family:"+FName;
			style+="; font-size:"+(nPtSize*scFactFont)+"pt; color:#"+color+";";
			if(nSt&0x01)style+=" font-weight:bold;";
			if(nSt&0x02)style+=" font-style:italic;";
			if(nSt&0x04)style+=" text-decoration:underline;";
			if(nSt&0x08)style+=" text-decoration:line-through;";
			if(nSt&0x10)style+=" vertical-align:super;";
			if(nSt&0x20)style+=" vertical-align:sub;";
		if(nLS>1.0)style += " line-height:"+nLS+";";
			return '<SPAN STYLE="'+style+'">'+text+'</SPAN>';
		}
	}
	else
	{
		if((nSt&0x10)||(nSt&0x20))nPtSize=nPtSize*2/3;
		if (browserType == "NN") 
			{
			var attr='FACE="'+FName+'" COLOR="#'+color+'" POINT-SIZE="'+(nPtSize*scFactFont)+'"';
			var str="<FONT "+attr+">";
			if(nSt&0x01)str+="<B>";
			if(nSt&0x02)str+="<I>";
			if(nSt&0x04)str+="<U>";
			if(nSt&0x10)str+="<SUP>";
			if(nSt&0x20)str+="<SUB>";
			str+=text;
			if(nSt&0x20)str+="<\/SUB>";
			if(nSt&0x10)str+="<\/SUP>";
			if(nSt&0x04)str+="<\/U>";
			if(nSt&0x02)str+="<\/I>";
			if(nSt&0x01)str+="<\/B>";
			str+="<\/FONT>";
			return str;
			}
		else 
			{
			var style="font-family:"+FName;
			style+="; font-size:"+(nPtSize*scFactFont)+"pt; color:#"+color+";";
			if(nSt&0x01)style+=" font-weight:bold;";
			if(nSt&0x02)style+=" font-style:italic;";
			if(nSt&0x04)style+=" text-decoration:underline;";
			if(nSt&0x08)style+=" text-decoration:line-through;";
			if(nSt&0x10)style+=" vertical-align:super;";
			if(nSt&0x20)style+=" vertical-align:sub;";
			if(nLS>1.0)style += " line-height:"+nLS+";";
			return '<SPAN STYLE="'+style+'">'+text+'<\/SPAN>';
	}		
	}
}

function DivSt(id,l,t,w,h,vis,sx,sy,sc)	
{
	l=l*scFact;t=t*scFact;w=w*scFact;h=h*scFact;
	if (isIE2() == true)
	{
		
		if(isNS4){
			var attr='NAME="'+id+'" LEFT='+l+' TOP='+t;
			if(w>0)attr+=' WIDTH='+w;
			if(h>0)attr+=' HEIGHT='+h;
			if(vis!=-1)attr+=' VISIBILITY='+(vis?'SHOW':'HIDDEN');
			attr+=' CLIP="'+w+','+h+'"';
			return '<LAYER '+attr+'>';
		}
		else{
			var st="position:absolute; left:"+l+"px; top:"+t+"px;";
			if(w>0)st+=" width:"+w+"px;";
			if(h>0)st+=" height:"+h+"px;";
			if(vis!=-1)st+=" visibility:"+(vis?"visible;":"hidden;");
		if(l<-5000||!bSTr||isIE5) {
			    if(sx==256)st+=" filter:DropShadow(Color=#000000,OffX=1,OffY=1);";
			    else if(sx!=0||sy!=0)st+=" filter:DropShadow(Color=#"+sc+",OffX="+sx+",OffY="+sy+");";
			}
			st+=" overflow:hidden; clip:rect(0 "+w+" "+h+" 0)";
			return '<DIV ID="'+id+'" STYLE="'+st+'">';
		}
	}
	else
	{
		
		if (browserType=="NN") 
			{
			var attr='NAME="'+id+'" LEFT='+l+' TOP='+t;
			if(w>0)attr+=' WIDTH='+w;
			if(h>0)attr+=' HEIGHT='+h;
			if(vis!=-1)attr+=' VISIBILITY='+(vis?'SHOW':'HIDDEN');
			attr+=' CLIP="'+w+','+h+'"';
			return '<LAYER '+attr+'>';
			}
		else 
			{
			var st="position:absolute; left:"+l+"px; top:"+t+"px;";
			if(w>0)st+=" width:"+w+"px;";
			if(h>0)st+=" height:"+h+"px;";
			if(vis!=-1)st+=" visibility:"+(vis?"visible;":"hidden;");
		  if((l<-5000 || !bSTr) && isIE4) 
		  	{
		  	if(sx==256)st+=" filter:DropShadow(Color=#000000,OffX=1,OffY=1);";
		  	else if(sx!=0||sy!=0)st+=" filter:DropShadow(Color=#"+sc+",OffX="+sx+",OffY="+sy+");";
				}
			st+=" overflow:hidden; clip:rect(0 "+w+" "+h+" 0)";
			return '<DIV ID="'+id+'" STYLE="'+st+'">';
			}
	}
}

function DivEnd()
{
	if (isIE2() == true)
	{	
		return isNS4?"</LAYER>\n":"</DIV>\n";
	}
	else
	{
		return (browserType=="NN")?"<\/LAYER>\n":"<\/DIV>\n";
	}
}

function setIm(d,n,i){eval("d." + n + ".src=i");}

function NSLayer(PLNm,LNm)
{
	if (isIE2() == true)
	{
		if(!isNS4) return null;
		if(PLNm!="")return document.layers[PLNm].document.layers[LNm];   
		return document.layers[LNm];
	}
	else
	{
		if (browserType!="NN") return null;
		if(PLNm!="")return document.layers[PLNm].document.layers[LNm];   
		return document.layers[LNm];
	}
}

function Tick(time){this.Time=time;this.Events=new Array;}

function initEvent(LNm,PLNm,time,nIter,nMaxIter,act,x,y,viz,trD,script,url,target)
{
	if (isIE2() == true)
	{
		this.LNm=LNm;this.PLNm=PLNm;this.time=time;this.iter=nIter;this.maxiter=nMaxIter;this.act=act;
		this.x=x;this.y=y;this.viz=viz;this.trD=trD;this.script=script;this.url=url;this.target=target;
		if(LNm=="")this.d=null;
		else{
			if(isNS4)this.d=NSLayer(PLNm,LNm);
			else{this.d=document.all[LNm];this.s=this.d.style;}
		}
		this.ExecuteEvent=(isNS4?NSEvent:IEEvent);
		// round to nearest 1/1000 sec ...
		this.time = Math.floor((this.time * 1000) + 0.5) / 1000;
	}
	else
	{
		this.LNm=LNm;
		this.PLNm=PLNm;
		this.time=time;
		this.iter=nIter;
		this.maxiter=nMaxIter;
		this.act=act;
		this.x=x;
		this.y=y;
		this.viz=viz;
		this.trD=trD;
		this.script=script;
		this.url=url;
		this.target=target;
			
		if (LNm=="") this.d=null;
		else 
			{		
			var elt= getElement(LNm, document);
			if (elt) 
				{
				this.d=elt;
				this.s=this.d.style;
				}
			}
		
		this.ExecuteEvent=((browserType=="NN") ? NSEvent : IEEvent);
		if (browserType=="NN") this.d=NSLayer(PLNm,LNm);
		// round to nearest 1/1000 sec ...
		this.time = Math.floor((this.time * 1000) + 0.5) / 1000;
	}



}

function astEvent(LNm,PLNm,time,nIter,nMaxIter,act,x,y,viz,trD,script,url,target){
    this.init = initEvent;
    this.init(LNm,PLNm,time,nIter,nMaxIter,act,x,y,viz,trD,script,url,target);
}

function iterViz(ev){return (ev.iter==0||(ev.maxiter==1)||(((nLoop-1)%ev.maxiter)==(ev.iter-1)));}

function NSEvent(){
	if(!iterViz(this)) return false;
	if(this.act&PAUSE){pauseSlide(this.x,this.y); return true;}
	if(this.act&ACTION){eval(this.script); jumpTo(this.url,this.target);}
	if(this.d==null)return false;
	if((this.act&CLIP) && this.trD){this.d.clip.left=this.trD[0];this.d.clip.top=this.trD[1];this.d.clip.width=this.trD[2]-this.trD[0];this.d.clip.height=this.trD[3]-this.trD[1];}
	if(this.act&MOVE)this.d.moveTo(this.x,this.y);
	if(this.act&SIZE)this.d.resizeTo(this.trD[4],this.trD[5]);
	if(this.act&VIZ)this.d.visibility=(this.viz == 0)?'hide':'show';
	if(this.act&MMSTRT)playNS(this,false);
	if(this.act&RPSTRT)playNS(this,true);
	if(this.act&STARTTL)controlObj(this.PLNm,this.LNm,0);
	return false;
}

function IEEvent() 
{
	if (isIE2() == true)
	{
		if(!iterViz(this)) return false;
		if(this.act&PAUSE){pauseSlide(this.x,this.y); return true;}
		if(this.act&ACTION){eval(this.script); jumpTo(this.url,this.target);}
		if(this.d==null)return false;
		if((this.act&CLIP) && this.trD)this.s.clip="rect("+this.trD[1]+" "+this.trD[2]+" "+this.trD[3]+" "+this.trD[0]+")";
		if(this.act&MOVE){this.s.left=this.x;this.s.top=this.y;}
		if(this.act&SIZE){if(this.trD[4])this.s.width=this.trD[4];if(this.trD[5])this.s.height=this.trD[5];}
		if(this.act&VIZ)this.s.visibility=(this.viz == 0)?'hidden':'visible';
		if(this.act&MMSTRT)playIE(this,false);
		if(this.act&RPSTRT)playIE(this,true);
		if(this.act&STARTTL)controlObj(this.PLNm,this.LNm,0);
		if(this.act&IETRANS){
			var sec=Math.floor(this.trD[2]/1000);
			var msec=Math.floor(this.trD[2]-sec*1000);
			if(this.trD[0]==-1)this.s.filter+=" blendtrans(duration="+sec+"."+msec+")";
			else this.s.filter+=" revealtrans(duration="+sec+"."+msec+",transition="+(this.trD[0]-1)+")";
		    this.s.visibility=(this.trD[1]==0)?"hidden":"visible";
		    var tdfl = this.d.filters.length - 1;
		    if (tdfl>=0)
		    {
			this.d.filters[tdfl].apply();
			this.s.visibility=(this.trD[1]==0)?"visible":"hidden";
			this.d.filters[tdfl].play();
		    }
		}
		return false;
	}
	else
	{
		var prefix = 'IEEvent(), ';
		if(!iterViz(this)) {return false;}
		if(this.act&PAUSE){pauseSlide(this.x,this.y); return true;}
		if(this.act&ACTION){eval(this.script); jumpTo(this.url,this.target);}
		if(this.d==null){return false;}
		if((this.act&CLIP) && this.trD) {this.s.clip="rect("+this.trD[1]+" "+this.trD[2]+" "+this.trD[3]+" "+this.trD[0]+")";}
		if(this.act&MOVE){this.s.left=this.x;this.s.top=this.y;}
		if(this.act&SIZE){if(this.trD[4])this.s.width=this.trD[4];if(this.trD[5])this.s.height=this.trD[5];}
		if(this.act&VIZ)
			{
			this.s.visibility= (this.viz == 0)?'hidden':'visible';
			}
		if(this.act&IETRANS)
			{
			if(isIE4)
				{
				var sec=Math.floor(this.trD[2]/1000);
				var msec=Math.floor(this.trD[2]-sec*1000);
				if(this.trD[0]==-1)this.s.filter+=" blendtrans(duration="+sec+"."+msec+")";
				else this.s.filter+=" revealtrans(duration="+sec+"."+msec+",transition="+(this.trD[0]-1)+")";
			  this.s.visibility=(this.trD[1]==0)?"hidden":"visible";
			  var tdfl = this.d.filters.length - 1;
			  if (tdfl>=0)
			    {
					this.d.filters[tdfl].apply();
					this.s.visibility=(this.trD[1]==0)?"visible":"hidden";
					this.d.filters[tdfl].play();
			    }
				}
			}
		return false;
	}

}

function playNS(ev,r){
	if (!ev.d) return;
	if((em=ev.d.document.embeds[ev.LNm+"EMB"])==null)return;
	bPl=false;
	if(r){if(em.CanPlayPause()){em.DoPlayPause();bPl=true;}}
	else{em.play();bPl=true;}
	if(!bPl)shiftEv(ev,200);
}

function playIE(ev,r)
{
	if (isIE2() == true)
	{
		if((ob=document.all[ev.LNm+"OBJ"])==null)return;
		bPl=false;
		if(r){if(ob.CanPlayPause()){ob.DoPlayPause();bPl=true;}}
		else{if(ob.ReadyState==4&&ob.Filename!=""){ob.Run();bPl=true;}}
		if(!bPl)shiftEv(ev,200);
	}
	else
	{
		if(browserType == 'IE')
			{
			if((ob=document.all[ev.LNm+"OBJ"])==null) { return;}
			}
		else
			{
			if((ob=document.getElementById(ev.LNm+"OBJ"))==null) { return;}	
			}
		bPl=false;
		if(r)
			{
			if(ob.CanPlayPause())
				{ob.DoPlayPause();bPl=true;}
			}
		else
				{if(ob.ReadyState==4&&ob.Filename!=""){ob.Run();bPl=true;}}
		if(!bPl)shiftEv(ev,200);
	}
}

function playMM(PLNm,LNm,v, r){ 
    var ev=new astEvent(LNm,PLNm,0,0,1,r?RPSTRT:MMSTRT,-1,-1,1,null,'','','');
    ev.ExecuteEvent();
}

function controlObj(PLNm, LNm, type){
	var tl=null;
	for(var i=1;i<document.tls.length;i++){
		tl=document.tls[i];
		if (tl.LNm==LNm&&tl.PLNm==PLNm){
			switch (type){
				case 0: tl.nTimeIndex=0; tl.bActive=true; break;
				case 1: tl.nTimeIndex=0; tl.bActive=false; break;
				case 2: tl.nTimeIndex=0; tl.bActive=!tl.bActive; break;
				case 4: tl.nTimeIndex=tl.nExitIndex; break;
			}
            var tick;
			if (tl.bActive) {
				tick=tl[tl.nTimeIndex];
				for(var j=0;j<tick.Events.length;j++)tick.Events[j].ExecuteEvent();
			}
			tick=tl[tl.nSteps+(tl.bActive?1:2)];
			tick.Events[0].ExecuteEvent();
			break;
		}
	}
}

function Div(LNm,PLNm){this.LNm=LNm;this.PLNm=PLNm;}

function State(LNm,PLNm){this.LNm=LNm;this.PLNm=PLNm;this.viz=0;this.x=0;this.y=0;this.trD=null;}

function jumpTo(url,target)
{
	
if (!isIE2())
	{
	var pattern = new String('/util/first_slide_proxy.html');
	var ind = url.indexOf(pattern);
	if(ind != -1)
		{
		var endurl = url.substr(ind + pattern.length);
		url = url.substr(0,ind);
		url += '/altbrowserutil/first_slide_proxy.html';
		url += endurl;
		}
	}
	
if (isIE2() == true)
	{
		if(url==''||url=='#') return;
	    if(isNS4&&window.endMouseEvents)endMouseEvents(); 
	    if(url.substring(0,11).toLowerCase()=="javascript:")eval(url.substring(11,url.length));
		else {
			bDoingJump=true; 
			parentFrame=getParent();
			if (target=='')	target="_self";
			if (target=='_self'&&parentFrame) {
				if (parentFrame.SetSlideFrameStatus) parentFrame.SetSlideFrameStatus(false);
				if (parentFrame.setCurrentURL) parentFrame.setCurrentURL(url);
			}
			if(bPlayer) open(url,target);
			else {
				if(parent.setCurrentSlide)
					parent.setCurrentSlide(url);
				else
					open(url,target);
				}
			}
	}
	else
	{
		if(url==''||url=='#') return;
		if (browserType=="NN" && window.endMouseEvents) endMouseEvents(); 
		if(url.substring(0,11).toLowerCase()=="javascript:")
			eval(url.substring(11,url.length));
		else
			{
			bDoingJump=true; 
			parentFrame=getParent();
			if (target=='')	target="_self";
			if (target=='_self'&&parentFrame) 
				{
				if (parentFrame.SetSlideFrameStatus) parentFrame.SetSlideFrameStatus(false);
				if (parentFrame.setCurrentURL) parentFrame.setCurrentURL(url);
				}
			if(bPlayer) open(url,target);
			else {
				if(parent.setCurrentSlide)
					parent.setCurrentSlide(url);
				else
					open(url,target);
				}				
			}
	}
}

function jumpToNextEvent() {
    var n=nTimeIndex;
    while (n<MainTL.length) {
	    if (MainTL[n].Events.length > 0) break;
	    n++;
    }
    jumpToTime(n*INDEXMUL,0,-1);
}

// This "time" is not really time - it's (TL Index) * INDEXMUL + (event bin index)
function jumpToTime(nT,nP,nO)
{
	if (isIE2() == true)
	{
		if(nT<0)nT=0;
	    var nIndex = Math.floor(nT/INDEXMUL);
	    if (nIndex >= MainTL.length) nIndex = MainTL.length-1;
	    var nRestartIndex = nT - (nIndex*INDEXMUL);
	    if(MainTL && MainTL[nIndex] && MainTL[nIndex].Events)
	    	if (nRestartIndex >= MainTL[nIndex].Events.length) nRestartIndex = MainTL[nIndex].Events.length-1;
	    if(nRestartIndex < 0) nRestartIndex = 0;
	    if (nIndex == nTimeIndex && nRestartIndex == nRestart) 
		return;
		var state=new Array;
		var ind=new Array;
	    var i,j,n;
		for(i=0;i<Divs.length;i++){
			if(Divs[i].LNm=="")continue;
			eval("ind."+Divs[i].LNm+"=i");
			state[i]=new State(Divs[i].LNm,Divs[i].PLNm);
		}
		var tick,ev;
		for(i=0;i<=nIndex;i++){
			tick=MainTL[i];
			for(j=0;j<tick.Events.length;j++){
		    if(i >= nIndex && j >= nRestartIndex) break;
				ev=tick.Events[j];
				if(ev.LNm=="") continue;
				n=ind[ev.LNm]
				state[n].LNm=ev.LNm;
				state[n].PLNm=ev.PLNm;
				if(ev.act&VIZ) state[n].viz=(iterViz(ev)?ev.viz:false);
				if(ev.act&MOVE) {state[n].x=ev.x;state[n].y=ev.y;}
				if(ev.act&CLIP) state[n].trD=ev.trD;
			}
		}
		var st,l,d,s;
		for(i=0;i<state.length;i++){
			st=state[i];
			if(st.LNm=="")return;
			if(isNS4){
				l=NSLayer(st.PLNm,st.LNm);
				if(!l) return;
				if(st.trD){l.clip.left=st.trD[0];l.clip.top=st.trD[1];l.clip.width=st.trD[2]-st.trD[0];l.clip.height=st.trD[3]-st.trD[1];}
				l.moveTo(st.x,st.y);l.visibility=(st.viz == 0)?'hide':'show';
			}
			else{
				d=document.all[st.LNm];s=d.style;
				if(st.trD)s.clip="rect("+st.trD[1]+" "+st.trD[2]+" "+st.trD[3]+" "+st.trD[0]+")";
				s.left=st.x;s.top=st.y;s.visibility=(st.viz == 0)?'hidden':'visible';
			}
		}
		nTimeIndex=nIndex;
	    nRestart=nRestartIndex;
		nGlobalTime=nTimeIndex*nGTStep;
		tm = new Date();
		startTime = tm.getTime();
		startTime -= nTimeIndex*nGTStep;
	    if (nP!=-1) {
			bPause=(nP==1)?true:false;
			bTimedPause=false;
			nPausedTime=0;
			bClickUnpause=true;
	    }
	    if (nO != -1) nOdo = nO;
		if(bStopped)DoTimeLine();
	}
	else
	{
		if (nT<0) nT=0;
		var nIndex = Math.floor(nT/INDEXMUL);
		if (nIndex >= MainTL.length) nIndex = MainTL.length-1;
		var nRestartIndex = nT - (nIndex*INDEXMUL);

 		if(MainTL && MainTL[nIndex] && MainTL[nIndex].Events)		    
			if (nRestartIndex >= MainTL[nIndex].Events.length) nRestartIndex = MainTL[nIndex].Events.length-1;
		if(nRestartIndex < 0) nRestartIndex = 0;
		if (nIndex == nTimeIndex && nRestartIndex == nRestart) return;
		    
		var state=new Array;
		var ind=new Array;
		var i,j,n;
		    
		for(i=0;i<Divs.length;i++) 
		{
			if(Divs[i].LNm=="")continue;
			eval("ind."+Divs[i].LNm+"=i");
			state[i]=new State(Divs[i].LNm,Divs[i].PLNm);
		}
			
		var tick,ev;
		for(i=0;i<=nIndex;i++) 
			{
			tick=MainTL[i];
			for(j=0;j<tick.Events.length;j++) 
				{
		    if(i >= nIndex && j >= nRestartIndex) break;
				ev=tick.Events[j];
				if(ev.LNm=="") continue;
				n=ind[ev.LNm];
				state[n].LNm=ev.LNm;
				state[n].PLNm=ev.PLNm;
				if(ev.act&VIZ) state[n].viz=(iterViz(ev)?ev.viz:false);
				if(ev.act&MOVE) {state[n].x=ev.x;state[n].y=ev.y;}
				if(ev.act&CLIP) state[n].trD=ev.trD;
			}
		}
			
		var st,l,d,s;
		for(i=0;i<state.length;i++) 
			{
			st=state[i];
			if(st.LNm=="")return;
			if (browserType=="NN") 
				{
				l=NSLayer(st.PLNm,st.LNm);
				if(!l) return;
				if(st.trD)
					{
					l.clip.left=st.trD[0];
					l.clip.top=st.trD[1];
					l.clip.width=st.trD[2]-st.trD[0];
					l.clip.height=st.trD[3]-st.trD[1];
					}
				l.moveTo(st.x,st.y);
				l.visibility=(st.viz == 0)?'hide':'show';
				}
			else 
				{
				d=getElement(st.LNm, document);
				if (d) 
					{ 
					s=d.style;
					if(st.trD)s.clip="rect("+st.trD[1]+" "+st.trD[2]+" "+st.trD[3]+" "+st.trD[0]+")";
					s.left=st.x;
					s.top=st.y;
					s.visibility=(st.viz == 0)?'hidden':'visible';
					}
				}
			}
			
		nTimeIndex=nIndex;
		nRestart=nRestartIndex;
		nGlobalTime=nTimeIndex*nGTStep;
		tm = new Date();
		startTime = tm.getTime();
		startTime -= nTimeIndex*nGTStep;
		if (nP!=-1) 
			{
			bPause=(nP==1)?true:false;
			bTimedPause=false;
			nPausedTime=0;
			bClickUnpause=true;
			}
		
		if (nO != -1) nOdo = nO;
		if(bStopped)DoTimeLine();
	}
}

function mkPath(init){
	if(init)pathArray.length=0;
	var index=pathArray.length;
	for(var i=1;i<mkPath.arguments.length;i++,index++){pathArray[index]=mkPath.arguments[i]*(((i%3)==1)?1:scFact);}
}

function mkTrans(which){
	var tr=new Array;
	var bClip=mkTrans.arguments[1]==2;
    var i, j;
	for(j=0,i=1;i<mkTrans.arguments.length;i++,j++){tr[j]=mkTrans.arguments[i]*((bClip&&(i>1))?scFact:1);}
	if(which)trOut=tr;
	else trIn=tr;	
}

function InsertEvent(tl,nIndex,ev) {
    if (nIndex>=tl.length) nIndex=tl.length-1;
    evList=tl[nIndex].Events;
    var nInsert=0;
    for(; nInsert<evList.length; nInsert++) { 
        if (ev.time<evList[nInsert].time) break;
    }
    if (ev.act==PAUSE) { arrPauses[arrPauses.length]=nIndex*INDEXMUL+nInsert+1; }    
    var evNext;
    var evIns = ev;
    do {
        evNext=(nInsert>=evList.length)?null:evList[nInsert];
        evList[nInsert]=evIns;
        evIns=evNext;
        nInsert++;
    } while (evNext!=null)
}

function addEvent(LNm,PLNm,tl,nIter,nMaxIter,time,act,x,y,viz,trD){
	if(PLNm!=""&&time!=0&&tl==MainTL)time+=nSTT;
	var nIndex=Math.floor(time/nGTStep);
    InsertEvent(tl,nIndex,new astEvent(LNm,PLNm,time,nIter,nMaxIter,act,x,y,viz,trD,"","",""));
}

function addActionEvent(time,script,url,target) {
	time+=nSTT;
	var nIndex=Math.floor(time/nGTStep);
    InsertEvent(MainTL,nIndex,new astEvent("","X",time,0,0,ACTION,0,0,1,"",script,url,target));
}

function shiftEv(ev,delt){
	var nIndex=Math.floor(nTimeIndex+delt/nGTStep);
	if(nIndex<MainTL.length){
		evList=MainTL[nIndex].Events;
		evList[evList.length]=ev;
	}
}

function addItem(LNm,PLNm,nInter,nIter,nMaxIter,nTStep,trI,trO,T1,T2,T3,T4,nState,x,y,p,mmType)
{
	if (isIE2() == true)
	{
	    var bInter=(nInter&0x0001);
	    if (bInter) 
		T2--; // make sure end of interactive object tmeline fits within the main timeline step 
		x=x*scFact;
		y=y*scFact;
		if(nTStep < nGTStep)
		    nTStep=nGTStep;
		var fact=nDur/MAXTM;
		Divs[numDivs++]=new Div(LNm,PLNm);
		var nT1=T1*fact,nT2=T2*fact,nT3=T3*fact,nT4=T4*fact;
		var tl = MainTL;
		if (bInter)
		{
			nT4-=nT1; nT3-=nT1; nT2-=nT1; nT1=0;
		    if(nT3<=nT2+nGTStep)
			nT3=nT2+nGTStep;
		    if(nT4<=nT3+nGTStep)
			nT4=nT3+nGTStep;
		    tl = document.tls[document.tls.length] = new Array;
			var nSteps=Math.floor(nT4/nGTStep);
			for(var i=0;i<=nSteps+2;i++)
			    tl[i]=new Tick(i*nGTStep);
			tl.LNm=LNm;
			tl.PLNm=PLNm;
			tl.bActive=false;
			tl.nTimeIndex=0;
			tl.nSteps=nSteps;
		tl.bHideClick=(nInter&0x0004)?true:false;
			tl.nExitIndex=Math.floor(nT3/nGTStep);
			addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT4+nGTStep,VIZ,0,0,1,null);
			addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT4+2*nGTStep,VIZ,0,0,0,null);
		}
		if((p==null || p.length<6) && trI==null && trO==null)	
		{
			addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT1,VIZ|MOVE,x,y,1,null);
			if(T4!=MAXTM || bInter)
			    addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT4,VIZ,0,0,0,null);
		}
		else
		{
			var path=new Array;
			if(p==null || p.length<6)
			{
				if(p==null)p=path;
				p.length=0;
				p[0]=T1;
				p[3]=T2;
				p[6]=T3;
				p[9]=T4;
				p[1]=p[4]=p[7]=p[10]=p[2]=p[5]=p[8]=p[11]=0;
			}
			var j,delj,nTStart,nTEnd,nT,x1,y1,x2,y2,delX,delY,trD,tr,xShift,yShift,xx,yy,act;
			nTStart=p[0]*fact;
			if (bInter) 
			    nTStart = 0;
			x1=p[1]+x;
			y1=p[2]+y;
			var bFirst=true;
			if(trI!=null && trI[0]==1)
			{
				trD=new Array(trI[1],0,nT2-nT1);
			addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT1,VIZ,0,0,0,null);
				addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT1+1,VIZ|IETRANS,0,0,1,trD);
			}
			else
			addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT1,VIZ,0,0,1,null);
			if(trO!=null && trO[0]==1)
			{
				trD=new Array(trO[1],1,nT4-nT3);
				addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT3+1,IETRANS,0,0,1,trD);
			}
			for(var i=3;i<p.length;i+=3)
			{
				nTEnd=p[i]*fact;
				if (bInter) 
				    nTEnd = (p[i]-p[0])*fact;
				x2=p[i+1]+x;
				y2=p[i+2]+y;
				delX=x2-x1;
				delY=y2-y1;
				tm=nTStart;
				bDone=false;
				delj=((nTEnd==nTStart)?0:nTStep/(nTEnd-nTStart));
				j=0;
				do {
					tr=null;trD=null;act=MOVE;
					xx=x1+j*delX;yy=y1+j*delY;
					if(trI!=null && trI[0]==2 && tm>=nT1-0.5 && tm<=nT2+0.5){
						tr=trI;
						rat=((nT2==nT1)?1:(tm-nT1)/(nT2-nT1));
					}
					if(trO!=null && trO[0]==2 && tm>=nT3-0.5 && tm<=nT4+0.5){
						tr=trO;
						rat=((nT4==nT3)?1:(tm-nT3)/(nT4-nT3));
					}
					if(tr!=null){
						xShift=tr[1]+(tr[7]-tr[1])*rat;
						yShift=tr[2]+(tr[8]-tr[2])*rat;
						trD=new Array(tr[3]+(tr[9]-tr[3])*rat,tr[4]+(tr[10]-tr[4])*rat,tr[5]+(tr[11]-tr[5])*rat,tr[6]+(tr[12]-tr[6])*rat);
						act|=CLIP;
						xx+=xShift;
						yy+=yShift;
					}
					if(bFirst||delX!=0||delY!=0||tr!=null)
					    addEvent(LNm,PLNm,tl,nIter,nMaxIter,tm,act,xx,yy,1,trD);
					bFirst=false;
					if(tm==nTEnd)
					    bDone=true;
					tm+=nTStep;
					j+=delj;
					if(tm>nTEnd)
					{
					    tm=nTEnd;
					    j=1;
					}
				}
				while(!bDone);
				x1=x2;
				y1=y2;
				nTStart=nTEnd;
			}
			if(T4!=MAXTM || bInter)
			    addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT4,VIZ,0,0,0,null);
		}
		if(mmType>0)
		{
		    del=(isIE4?screen.updateInterval:nGTStep);
		    if(del<nGTStep)
			del=nGTStep;
		    addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT1+del,mmType==2?RPSTRT:MMSTRT,0,0,0,null);
		}
	}
	else
	{
		var bInter=(nInter&0x0001);
		if (bInter) 
			T2--; // make sure end of interactive object tmeline fits within the main timeline step 
		x=x*scFact;
		y=y*scFact;
		if(nTStep < nGTStep)
			nTStep=nGTStep;
		
		var fact=nDur/MAXTM;
		Divs[numDivs++]=new Div(LNm,PLNm);
		var nT1=T1*fact,nT2=T2*fact,nT3=T3*fact,nT4=T4*fact;
		var tl = MainTL;
		if (bInter)
			{
			nT4-=nT1; nT3-=nT1; nT2-=nT1; nT1=0;
			if(nT3<=nT2+nGTStep)
				nT3=nT2+nGTStep;
			if(nT4<=nT3+nGTStep)
				nT4=nT3+nGTStep;
			tl = document.tls[document.tls.length] = new Array;
			var nSteps=Math.floor(nT4/nGTStep);
			for(var i=0;i<=nSteps+2;i++)
				tl[i]=new Tick(i*nGTStep);
		
			tl.LNm=LNm;
			tl.PLNm=PLNm;
			tl.bActive=false;
			tl.nTimeIndex=0;
			tl.nSteps=nSteps;
			tl.bHideClick=(nInter&0x0004)?true:false;
			tl.nExitIndex=Math.floor(nT3/nGTStep);
			addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT4+nGTStep,VIZ,0,0,1,null);
			addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT4+2*nGTStep,VIZ,0,0,0,null);
			}
		
		if((p==null || p.length<6) && trI==null && trO==null)	
			{
			addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT1,VIZ|MOVE,x,y,1,null);
			if(T4!=MAXTM || bInter)
			addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT4,VIZ,0,0,0,null);
			}
		else
			{
			var path=new Array;
			if(p==null || p.length<6)
				{
				if(p==null)p=path;
				p.length=0;
				p[0]=T1;
				p[3]=T2;
				p[6]=T3;
				p[9]=T4;
				p[1]=p[4]=p[7]=p[10]=p[2]=p[5]=p[8]=p[11]=0;
				}
		
			var j,delj,nTStart,nTEnd,nT,x1,y1,x2,y2,delX,delY,trD,tr,xShift,yShift,xx,yy,act;
			nTStart=p[0]*fact;
			if (bInter) 
				nTStart = 0;
		
			x1=p[1]+x;
			y1=p[2]+y;
			var bFirst=true;
			if(trI!=null && trI[0]==1)
				{
				trD=new Array(trI[1],0,nT2-nT1);
				addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT1,VIZ,0,0,0,null);
				addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT1+1,VIZ|IETRANS,0,0,1,trD);
				}
			else
				addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT1,VIZ,0,0,1,null);
		
			if(trO!=null && trO[0]==1)
				{
				trD=new Array(trO[1],1,nT4-nT3);
				addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT3+1,IETRANS,0,0,1,trD);
				}
		
			for(var i=3;i<p.length;i+=3)
				{
				nTEnd=p[i]*fact;
				if (bInter) 
					nTEnd = (p[i]-p[0])*fact;
				x2=p[i+1]+x;
				y2=p[i+2]+y;
				delX=x2-x1;
				delY=y2-y1;
				tm=nTStart;
				bDone=false;
				delj=((nTEnd==nTStart)?0:nTStep/(nTEnd-nTStart));
				j=0;
				do
					{
					tr=null;trD=null;act=MOVE;
					xx=x1+j*delX;yy=y1+j*delY;
					if(trI!=null && trI[0]==2 && tm>=nT1-0.5 && tm<=nT2+0.5)
						{
						tr=trI;
						rat=((nT2==nT1)?1:(tm-nT1)/(nT2-nT1));
						}
					if(trO!=null && trO[0]==2 && tm>=nT3-0.5 && tm<=nT4+0.5)
						{
						tr=trO;
						rat=((nT4==nT3)?1:(tm-nT3)/(nT4-nT3));
						}
					if(tr!=null)
						{
						xShift=tr[1]+(tr[7]-tr[1])*rat;
						yShift=tr[2]+(tr[8]-tr[2])*rat;
						trD=new Array(tr[3]+(tr[9]-tr[3])*rat,tr[4]+(tr[10]-tr[4])*rat,tr[5]+(tr[11]-tr[5])*rat,tr[6]+(tr[12]-tr[6])*rat);
						act|=CLIP;
						xx+=xShift;
						yy+=yShift;
						}
					if(bFirst||delX!=0||delY!=0||tr!=null)
					  addEvent(LNm,PLNm,tl,nIter,nMaxIter,tm,act,xx,yy,1,trD);
					bFirst=false;
					if(tm==nTEnd)
					  bDone=true;
					tm+=nTStep;
					j+=delj;
					if(tm>nTEnd)
						{
						tm=nTEnd;
						j=1;
						}
					}
				while(!bDone);
		
				x1=x2;
				y1=y2;
				nTStart=nTEnd;
				}
		
			if(T4!=MAXTM || bInter)
				addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT4,VIZ,0,0,0,null);
			}
		
		if(mmType>0)
			{
			del=(isIE4?screen.updateInterval:nGTStep);
			if(del<nGTStep)
				del=nGTStep;
			addEvent(LNm,PLNm,tl,nIter,nMaxIter,nT1+del,mmType==2?RPSTRT:MMSTRT,0,0,0,null);
			}
	}
}

function addPause(nT,nD,bClick){addEvent("","X",MainTL,0,0,nT*nDur/MAXTM,PAUSE,nD,bClick,0,null);}
function setStartTL(LNm,PLNm,nT){addEvent(LNm,PLNm,MainTL,0,0,nT*nDur/MAXTM+nGTStep,STARTTL,0,0,0,null);}
function addMarker(nT,script,url,target){addActionEvent(nT*nDur/MAXTM,script,url,target);}
function setNext(URL){nextURL=URL;}
function setNextTmp(URL,target){if(bStopped==true)jumpTo(URL,target);else {nextURLTmp=URL;nextURLTmpTarget=target;}}


function GetStatusMSG() {
    return strStatus;
}

function SetStatusMSG(str) {
    strStatus=str;
	window.status=str;
}

function stat(){
	var str="";
	if(bPause){
		str+="Paused";
		if(bTimedPause)str+=" ["+nPauseTime/1000+" sec]";
		if(bClickUnpause)str+=": Click to continue";
	}
    SetStatusMSG(str);
}



function EndTL() {
	bStopped=true;
	bDoUnload = true;
	if(RangeLast!=""&&(RangeLast==getFName(location.pathname)))	{
		clearRange();
		if (AfterRange!="")	{
			jumpTo(AfterRange+paramsToS(params),"_self");
			return;
		}
	}
    s=paramsToS(params);
    var bSelf=false;
	if(nextURLTmp!=null){u=nextURLTmp;nextURLTmp=null;bSelf=(nextURLTmpTarget=="_self");tg=nextURLTmpTarget;nextURLTmpTarget=null;jumpTo(u+s,tg);}
	if(!bSelf&&nextURL!=null)jumpTo(nextURL+s,"_self");
}

function DoTimeLine()
{
	if (isIE2() == true)
	{
	    // We need to do this here rather than in resizeCalled, because we need the new 
	    //  frame size AFTER the resize
	    if (bCheckScale)
	    {
		bCheckScale = false;
		if (bDoPickscale)
		{
		    var strNewSizeDir = getSizeDir();
			if (strNewSizeDir != getCurrentSizeDir())
			{
			resizeReload(replaceSizeDir(location.pathname, strNewSizeDir));
				return;
			}
		}
		if (bDoAutoscale && !isNS4)
		{
			if (scFact != getScaleFactor())
			{
			resizeReload(location.pathname);
				return;
			}
		}
	    }
		bStopped = false;
		nGlobalTime = nTimeIndex*nGTStep;
		if(bPause)
		{
			nPauseTime -= 100;
			if(bTimedPause && nPauseTime < 0)
			unpauseSlide();
			else
			{
			    setTimeout("DoTimeLine()",100);stat();
			    return;
			}
		}
	    if(nTimeIndex >= MainTL.length) 
	    { 
		EndTL(); 
		return; 
	    }
		var t;
		do 
		{ 
		    t = new Date(); 
		    curTime = t.getTime();
		} 
		while (curTime - startTime < nGlobalTime); // resync time ...

		if (((loopCount%5) == 0) && nGlobalTime > nSTT && parentFrame && parentFrame.SetTime)
			parentFrame.SetTime ((bTimedSlide ? nGlobalTime : curTime - realStartTime) - nSTT, nDur, bTimedSlide);
		loopCount++;
		var tl;
		var tick;
		tick = MainTL[nTimeIndex];
	    var bP = false;
	    nOdo++;
		for(i = nRestart; i < tick.Events.length; i++)
		{
		    bP = tick.Events[i].ExecuteEvent();
		if (bP) 
		{
		    nRestart=i+1; 
        var nPauseTime = GetTime();
        var nMaxPause = 0;
		if(!bPlayer) {
	        for (ii = 0; ii < arrPauses.length; ii++)
    	    	{
        	  	if(arrPauses[ii] > nMaxPause)
            		nMaxPause = arrPauses[ii];
        		}	
        
        	if (nPauseTime >= nMaxPause)
        		{	
	        	// at end of slide ...
    	    	// a hack - need to inform NIke about end of slide ...
				//          sendConfEvent(9,"","",0,0,0);
        		}
			}
		    setTimeout("DoTimeLine()",10); 
		    return;
		}
		}
	    nRestart=0;
		nTimeIndex++; 
		for(var ntl = 1; ntl<document.tls.length; ntl++)
		{
			tl = document.tls[ntl];
			if (tl.bActive && tl.nTimeIndex <= tl.nSteps)
			{
				tick=tl[tl.nTimeIndex++];
				for(var i = 0; i < tick.Events.length; i++)
				    tick.Events[i].ExecuteEvent();
			}
		}
		if(nGlobalTime + nGTStep <= nLoopEnd + nSTT) 
		    setTimeout("DoTimeLine()",nDelay);
		else 
		{
			if (nLoop < nMaxLoop)
			{
			    bStopped=true;nLoop++;
			    jumpToTime(nTLoopStart*INDEXMUL,0,-1);
			}
			else 
			    setTimeout("DoTimeLine()",nDelay);
		}
	}
	else
	{
		clearTimeout(doTimeLineTimer);
		
		// We need to do this here rather than in resizeCalled, because we need the new frame size AFTER the resize
		if (bCheckScale)
			{
			bCheckScale = false;
			if (bDoPickscale)
				{
				var strNewSizeDir = getSizeDir();
				if (strNewSizeDir != getCurrentSizeDir())
					{
				  resizeReload(replaceSizeDir(location.pathname, strNewSizeDir));
					return;
					}
				}
		
			if (bDoAutoscale && browserType!="NN")
			{
				if (scFact != getScaleFactor())
				{
			    resizeReload(location.pathname);
					return;
				}
			}
		}
			
		bStopped = false;
		nGlobalTime = nTimeIndex*nGTStep;
		if(bPause)
			{
			nPauseTime -= 100;
			if(bTimedPause && nPauseTime < 0)
				{
				unpauseSlide();
				}
			else
				{
				doTimeLineTimer=setTimeout("DoTimeLine()",100);
				stat();
				return;
				}
			}
		
		if(nTimeIndex >= MainTL.length) 
			{ 
			EndTL(); 
			return; 
			}
		
		var t;
		
		do 
			{ 
			t = new Date(); 
			curTime = t.getTime();
			} 
		while (curTime - startTime < nGlobalTime); // resync time ...
		
		if (((loopCount%5) == 0) && nGlobalTime > nSTT && parentFrame)
		{
		    try {
		        if (parentFrame.SetTime)
			        parentFrame.SetTime ((bTimedSlide ? nGlobalTime : curTime - realStartTime) - nSTT, nDur, bTimedSlide);
			}
			catch (err)
			{
			    debugger;
		        parentFrame=getParent();
			}
		}
		
		loopCount++;
		
		var tl;
		var tick;
		tick = MainTL[nTimeIndex];
		var bP = false;
		nOdo++;
		
		for(i = nRestart; i < tick.Events.length; i++)
			{
			bP = tick.Events[i].ExecuteEvent();
			if (bP) 
				{
		  	nRestart=i+1; 
		  	doTimeLineTimer=setTimeout("DoTimeLine()",10); 
		  	return;
				}
			}
		
		nRestart=0;
		nTimeIndex++; 
		
		for(var ntl = 1; ntl<document.tls.length; ntl++)
			{
			tl = document.tls[ntl];
			if (tl.bActive && tl.nTimeIndex <= tl.nSteps)
				{
				tick=tl[tl.nTimeIndex++];
				for(var i = 0; i < tick.Events.length; i++)
					{
					tick.Events[i].ExecuteEvent();
					}
				}
			}
		
		if(nGlobalTime + nGTStep <= nLoopEnd + nSTT) 
			{
			doTimeLineTimer=setTimeout("DoTimeLine()",nDelay);
			}
		else 
			{
			if (nLoop < nMaxLoop)
				{
				bStopped=true;nLoop++;
				jumpToTime(nTLoopStart*INDEXMUL,0,-1);
				}
			else 
				{
				doTimeLineTimer=setTimeout("DoTimeLine()",nDelay);
				}
			}	
	}
}




function setPresURL() {
	parentFrame=getParent();
    if (parentFrame && parentFrame.setPresURL) 
    {
        var strURL = location.href;
        if (bDoPickscale)
            strURL = removeSizeDir(strURL);
        parentFrame.setPresURL(strURL);
    }
}

function InitSlide(name,dur,nLoopSt,nLoop,tr,step,bTimed)
{
	if (isIE2() == true)
	{
	    sToParams(location.search,params);
		getParamData();
	    if (bRestoreAnnot)
		restoreAnnotState();

		strPageNm=name;
		nDur=dur;nTLoopStart=(nLoopSt*nDur/MAXTM)/step;nLoopEnd=nLoop;nSTT=tr;
		ui=screen.updateInterval;
		if(isIE4&&step<ui&&ui>50)step=ui;
		nGTStep=nTStep=step;
		nDelay=nGTStep*TimeWarp;
		nTimeIndex=0;
		bTimedSlide=bTimed;
		var nSteps=(dur+tr)/step;
		for(var i=0;i<=nSteps;i++)MainTL[i]=new Tick(i*step);
		parentFrame=getParent();
		if (parentFrame) {
		    if (isIE4) parentFrame.document.title = document.title + "\xa0\xa0\xa0\x20\xa0\x20\xa0\xa0\xa0\xa0";
		    if (parentFrame.initFrameset) parentFrame.initFrameset(isNS4);
		    if (parentFrame.startPresSlide) parentFrame.startPresSlide();
		}
		return true;
	}
	else
	{
		sToParams(location.search,params);
		getParamData();
		if (bRestoreAnnot)
			restoreAnnotState();
		
		strPageNm=name;
		nDur=dur;nTLoopStart=(nLoopSt*nDur/MAXTM)/step;nLoopEnd=nLoop;nSTT=tr;
		ui=screen.updateInterval;
		if (isIE4&&step<ui&&ui>50) step=ui;
		nGTStep=nTStep=step;
		nDelay=nGTStep*TimeWarp;
		nTimeIndex=0;
		bTimedSlide=bTimed;
		var nSteps=(dur+tr)/step;
		
		for(var i=0;i<=nSteps;i++)
			MainTL[i]=new Tick(i*step);
		
		parentFrame=getParent();
		if (parentFrame) 
			{
			if (isIE4) parentFrame.document.title = document.title + "\xa0\xa0\xa0\x20\xa0\x20\xa0\xa0\xa0\xa0";
			if (parentFrame.initFrameset) parentFrame.initFrameset(browserType=="NN");
			if (parentFrame.startPresSlide) parentFrame.startPresSlide();
			}
		return true;
	}

}

function startTimeline()
{
if(!bPlayer) {
  	if(parent.setSlideLists)
		parent.setSlideLists(getSlideNames());
  	if(parent.slideLoaded)
		parent.slideLoaded(this.frameElement);
	}

  // for BC
  if(bIsBC)
	{
	if(bPlayer) setPresWidth();
	else {
		if(parent.currSlideIndex == this.frameElement.id.substr(10)) setPresWidth(this.frameElement);
  		}
	}

  if (isIE2() == true)
	{
		if (!bSlideLoaded) {
			bSlideLoaded = true;
			parentFrame=getParent();
			if (parentFrame && parentFrame.SetSlideFrameStatus)	parentFrame.SetSlideFrameStatus(true);
		}
		if(bStarted) return;
		if(checkImages(nTryTime)){
		    if (checkApplets(nTryTime)){
			bStarted=true;
			var start = new Date();
			realStartTime = startTime = start.getTime();
			loopCount=0;
		    loadNotes();
		    if(nOffsetTime>0) {bStopped=true;jumpToTime(nOffsetTime,nOffsetPause,nOffsetOdo);}
			else DoTimeLine();
		    return;
		}
		}
	    nTryTime+=WAITINC;
		setTimeout("startTimeline();",WAITINC);
	}
	else
	{
		clearTimeout(startTimeLineTimer)
		if (!bSlideLoaded) 
			{
			bSlideLoaded = true;
			parentFrame=getParent();
			if (parentFrame && parentFrame.SetSlideFrameStatus)	parentFrame.SetSlideFrameStatus(true);
			}
		
		if(bStarted) return;
		
		if (checkImages(nTryTime)) 
			{
			if (checkApplets(nTryTime))
				{
				bStarted=true;
				var start = new Date();
				realStartTime = startTime = start.getTime();
				loopCount=0;
				loadNotes();
				if(nOffsetTime>0) 
					{ 
					bStopped=true;
					jumpToTime(nOffsetTime,nOffsetPause,nOffsetOdo);
					}
				else DoTimeLine();
				return;
				}
			}
		nTryTime+=WAITINC;
		startTimeLineTimer=setTimeout("startTimeline();",WAITINC);
	}


}

function checkApplets(n)
{
	if (isIE2() == true)
	{
		if (!parentFrame||!parentFrame.appletsReady)
			return true;
		if (!parentFrame.appletsReady(n))
			return false;
		if (parentFrame.ConfIsConference&&parentFrame.ConfStartTL){
		var strURL = location.href;
		if (bDoPickscale)
		    strURL = removeSizeDir(strURL);
			if (parentFrame.ConfIsConference()&&(parentFrame.ConfStartTL(strURL)!=1)) return false;
		}
		if (bCBTNeedLogin&&parentFrame.LogIn&&!parentFrame.LogIn()){
			bDoUnload=false;
			parentFrame.location.href=strNoLoginURL;
			return false;
		}
		return true;
	}
	else
	{
		if (!parentFrame||!parentFrame.appletsReady)
			return true;
		if (!parentFrame.appletsReady(n))
			return false;
		if (parentFrame.ConfIsConference&&parentFrame.ConfStartTL)
			{
		  var strURL = location.href;
		  if (bDoPickscale)
			  strURL = removeSizeDir(strURL);
			if (parentFrame.ConfIsConference()&&(parentFrame.ConfStartTL(strURL)!=1)) return false;
			}
		if (bCBTNeedLogin&&parentFrame.LogIn&&!parentFrame.LogIn())
			{
			bDoUnload=false;
			parentFrame.location.href=strNoLoginURL;
			return false;
			}
return true;
	}

}

function checkImages(nT)
{
	if (isIE2() == true)
	{
	var nIm=0,nC=0;
	if (isNS4){
		for(var l=0;l<document.layers.length;l++){
			for(var s=0;s<document.layers[l].document.layers.length;s++){
				ims=document.layers[l].document.layers[s].document.images;
				if(ims.length>0){ nIm++; if(ims[0].complete==true)nC++;} 
			}
		}
	}
	else{
		for(var i=0;i<document.images.length;i++){
		    var r=document.images[i].readyState;
            if (r!="unitialized"&&r!="uninitialized"){ nIm++; if(r=="complete")nC++; }
		}
	}
    var bDone = (nIm==0)||(nC/nIm*100>=nImgPct)||(nT>MAXWAIT)||(nT>nImgPct*50*nIm);
    SetStatusMSG(bDone?"":"Waiting for Images to load ... ");
	return bDone;
	}
	else
	{
		var nIm=0,nC=0;
		if (browserType=="NN") 
			{
			for(var l=0;l<document.layers.length;l++)
				{
				for(var s=0;s<document.layers[l].document.layers.length;s++)
					{
					ims=document.layers[l].document.layers[s].document.images;
					if(ims.length>0){ nIm++; if(ims[0].complete==true)nC++;} 
					}
				}
			}
		else 
			{
			for(var i=0;i<document.images.length;i++)
				{
				if(isIE4)
					{
					var r=document.images[i].readyState;
					if (r!="unitialized"&&r!="uninitialized"){ nIm++; if(r=="complete")nC++; }
					}
				else if(isSafari())
					{
					// Safari doesn't support either img.complete or img.readyState => no way to check images loading
					nIm++;
					nC++;	
					}
				else
					{
					var r=document.images[i].complete;
					nIm++; if(r == true) nC++;
					}
				}
			}
		var bDone = (nIm==0) || (nC/nIm*100>=nImgPct) || (nT>MAXWAIT) || (nT>nImgPct*50*nIm);
		SetStatusMSG(bDone?"":"Waiting for Images to load ... ");
		return bDone;
	}
}

function pauseSlide(time,click){bPause=true;bTimedPause=(time!=-1);nPauseTime=time;bClickUnpause=click;}
function unpauseSlide(){bPause=false;stat();}

function getClickedLink(e)
{
   	if(isIE4)
   	{
       	if ((s=window.event.srcElement)!=null)
       	{
       	    if (s.parentElement!=null)
           	{
       	        if (s.parentElement.href != null && s.parentElement.href != "")
           	        return s.parentElement.href;
       	    }
            if (s.href != null && s.href != "" && s.href != s.src)
                return s.href;
            return "";
       	}
   	}
    else
    {
        if (e != null && e.target!=null)
            return e.target.href ? e.target.href : "";
	}
   	return "X";
}

function clickHandler(e)
{
	parentFrame=getParent();
	if(parentFrame.bIsBrowserClient && (parentFrame.bIsBrowserClient == true))
		{
		// ignore click events on slide on browser client
		return;
		}
	if (isIE2() == true)
		{
		if(!bMaskOn && getClickedLink(e)=="") 
	    {
			var tl;
			for(var i=1; i<document.tls.length; i++)
				{
		    tl=document.tls[i];
		    if (tl.bHideClick) controlObj (tl.PLNm,tl.LNm,1);
				}  
			if(bPause) { if(bClickUnpause)evUnpauseSlide(true); }
			else if (bAdvOnClick) jumpToNextEvent();
	    }
	  return !bMaskOn;
		}
	else
		{
		if(!bMaskOn && getClickedLink(e)=="") 
			{
			var tl;
			for(var i=1; i<document.tls.length; i++)
				{
				tl=document.tls[i];
				if (tl.bHideClick) 
					{
					controlObj (tl.PLNm,tl.LNm,1);
					}
		    }  
		  if(bPause) 
		  	{
		  	if(bClickUnpause)
		  		evUnpauseSlide(true); 
		  	}
		  else if (bAdvOnClick) jumpToNextEvent();
			}
		return !bMaskOn;
		}
}

function advanceOnClick(b) { bAdvOnClick=b; }

function setLooping(n){nMaxLoop=n;}

function resizeCalled(){
    if (bDoAutoscale || bDoPickscale)
    	{
		if(!bPlayer) {
			if(parent.setSlideLists)	//Stop check scale when using slide preload.
				bCheckScale = false;
			else
				bCheckScale = true;
    		}
		else bCheckScale = true;
		}
}

function resizeReload(url)
{
    saveAnnotState();            
    var pms = new Array;
    sToParams(url, pms);
    setResizeParams(pms);
	bDoUnload=false;
	open(url + paramsToS(pms), "_self");
}

function setResizeParams(pms)
{
if (getParam(params, NX) != "")
	setParam(pms, NX, getParam(params, NX));
if (getParam(params, RL) != "")
	setParam(pms, RL, getParam(params, RL));
if (getParam(params, AR) != "")
	setParam(pms, AR, getParam(params, AR));
setParam(pms,"a","t");
setParam(pms,"t",""+GetTime());
setParam(pms,"p",bPause?"1":"0");
setParam(pms,"o",""+nOdo);
// Browser client requires the BC param in URL...
if(bIsBC == true) setParam(pms,"BC","1");
}

function addCDFChannel(){ if(isIE4) document.location.href=cdfname; }

function addMyChannel()
{
	if (isIE2() == true)
	{
		if (isNS4) addNCChannelAPI();
		else addCDFChannel();
	}
	else
	{
		if (browserType=="NN")
			addNCChannelAPI();
		else addCDFChannel();
	}
}

function playRange(url1,url2,bReplay,bTime,bDelay)
{

	if (isIE2() == true)
	{
		setParam(params,NX,url1);
		setParam(params,RL,url2);
		if (bReplay){
			after=getFName(location.pathname);
			if(bTime) { 
			    after+="?t="+GetTime();
			    after+="&p="+(bPause?"1":"0");
			    after+="&o="+nOd;
		}
		}
		else after=nextURL;
		setParam(params,AR,after);
		if (bDelay) setNextTmp(url1,"_self");
		else jumpTo(url1+paramsToS(params),"_self");
	}
	else
	{
		setParam(params,NX,url1);
		setParam(params,RL,url2);
		if (bReplay)
			{
			after=getFName(location.pathname);
			if(bTime) 
				{ 
				after+="?t="+GetTime();
				after+="&p="+(bPause?"1":"0");
				after+="&o="+nOd;
				}
			}
		else after=nextURL;
		setParam(params,AR,after);
		if (bDelay)
			setNextTmp(url1,"_self");
		else
		jumpTo(url1+paramsToS(params),"_self");
	}
}


function getParamData(){
	RangeNext=getParam(params,NX);
	RangeLast=getParam(params,RL);
	AfterRange=getParam(params,AR);
    nOffsetTime=getTimeOffset();
    nOffsetPause=getPauseOffset();
    nOffsetOdo=getOdoOffset();
    bRestoreAnnot=getRestoreAnnot();
}

function getRestoreAnnot()
{
    str=getParam(params,"a");
    setParam(params,"a",null);
    return ((str=="t")?true:false);
}

function getTimeOffset() { 
    str=getParam(params,"t");
    setParam(params,"t",null);
    return ((str=="")?0:str);
}

function getPauseOffset() { 
    str=getParam(params,"p");
    setParam(params,"p",null);
    return ((str=="")?0:str);
}

function getOdoOffset() { 
    str=getParam(params,"o");
    setParam(params,"o",null);
    return ((str=="")?0:str);
}

function clearRange(){
    setParam(params,NX,null);
    setParam(params,RL,null);
    setParam(params,AR,null);
}

function getFName(path){
	var i=path.lastIndexOf('/');
	if (i<=0)i=path.lastIndexOf('\\');
	if(i<0) return path;
	return path.substring(i+1,path.length);
}

function getBase(path) {
	var i=path.indexOf('?');
	if (i>0) path=path.substring(0,i);
	i=path.lastIndexOf('/');
	if (i<=0)i=path.lastIndexOf('\\');
	if(i<0) return "";
	return path.substring(0,i+1);
}

function getCurrentSizeDir()
{
    var strBase = getBase(location.href);
    var strDir = getFName(strBase.substring(0,strBase.length-1));
    return strDir;
}

function replaceSizeDir(path, strSizeDir)
{
    var strFName = getFName(path);
    var strBase = getBase(path);
    var strBase2 = getBase(strBase.substring(0,strBase.length-1));
    return strBase2 + strSizeDir + "/" + strFName;
}

function removeSizeDir(path)
{
    var strFName = getFName(path);
    var strBase = getBase(path);
    var strDir = getFName(strBase.substring(0,strBase.length-1));
    strBase = strBase.substring(0, strBase.length - strDir.length-1);
    return strBase + strFName;
}

function Button (PLNm,LNm,name,type,src,srcDn,srcOvr)
{
	if (isIE2() == true)
	{
		if (isNS4){
			l=NSLayer(PLNm,LNm);
			this.img=(l?l.document.images[0]:null);
		}
		else
			this.img=document.images[name];
		this.name = name;
		this.type = type;
		this.src = src;
		this.srcDn = srcDn;
		this.srcOvr = srcOvr;
		this.state = false;
	}
	else
	{
		if (browserType=="NN") 
			{
			l=NSLayer(PLNm,LNm);
			this.img=(l?l.document.images[0]:null);
			}
		else
			this.img=document.images[name];
			
		this.name = name;
		this.type = type;
		this.src = src;
		this.srcDn = srcDn;
		this.srcOvr = srcOvr;
		this.state = false;
	}
}

function defBtn (PLNm,LNm,name,type,src,srcDn,srcOvr){
	btn = new Button(PLNm,LNm,name,type,src,srcDn,srcOvr);
	if (defBtn.arguments.length>7){
		btn.exclude = new Array;
		for(var i=7;i<defBtn.arguments.length; i++)
			btn.exclude[i-7]=defBtn.arguments[i];
	}
	docbtns[name]=btn;
}

function btnClick(name){
	var btn=docbtns[name];
	if(btn)
	{
		if (btn.type&BTN_TOGGLE) btn.state=!btn.state;
		else btn.state=true;
		if ((btn.type&BTN_EXCLUDE)&&btn.exclude){
			for(var i=0; i<btn.exclude.length; i++){
				btn2 = docbtns[btn.exclude[i]];
				if (btn2.name!=btn.name){
					btn2.state=false;
					btn2.img.src=btn2.src;
				}
			}
		}
		btn.img.src=(btn.state&&btn.srcDn!="")?btn.srcDn:btn.src;
	}
}

function btnUnclick(name){
	var btn=docbtns[name];
	if(btn)
	{
		if (btn.type&(BTN_TOGGLE|BTN_EXCLUDE))
			btn.img.src=(btn.state&&btn.srcDn!="")?btn.srcDn:btn.src;
		else {
			btn.state=false;
			btn.img.src=btn.src;
		}
	}

}

function btnOver(name){
	var btn=docbtns[name];
	if(btn&&btn.srcOvr!=""&&!btn.state)
		btn.img.src=btn.srcOvr;
}

function clickMask(bOn)
{
	if (isIE2() == true)
	{
	    if (bOn == 0){
		bOn = false;
	    }
	    else if (bOn == 1){
		bOn = true;
	    }
	    bMaskOn=bOn;

		if(isNS4){ d=NSLayer("",MASKLAYER); d.visibility=(bOn?"show":"hide"); }
		else{ d=document.all[MASKLAYER]; d.style.visibility=(bOn?"visible":"hidden"); }
	}
	else
	{
		if (bOn == 0)
			{
			bOn = false;
			}
		else if (bOn == 1)
			{
			bOn = true;
			}
		bMaskOn=bOn;
		
		var elt = getElement(MASKLAYER, document)
		if (elt) 
			{
			d=elt;
			if (browserType != "NN") 
				d.style.visibility=(bOn?"visible":"hidden"); 
			else
				d.visibility=(bOn?"show":"hide"); 
			}
	}
}

function blockDisplay(bOn)
{
	if (isIE2() == true)
	{
	    if(isNS4){d=NSLayer("",BLOCKLAYER);d.visibility=(bOn?"show":"hide");}
		else{d=document.all[BLOCKLAYER];d.style.visibility=(bOn?"visible":"hidden");}
	}
	else
	{
		var elt = getElement(BLOCKLAYER, document)
		if (elt)
			{
			d=elt;
			if (browserType!="NN")
				d.style.visibility=(bOn?"visible":"hidden");
			else
				d.visibility=(bOn?"show":"hide");
		}
	}
}


function setScore(n){SlideScore=n;}

function getScore(){ return SlideScore; }

function unloadSlide(){ 
    if(!bDoingJump)killNotes();
    if (parentFrame) {
        if (parentFrame.stopPresSlide) parentFrame.stopPresSlide();
        if (parentFrame.setPresURL) parentFrame.setPresURL("");
    	if (bDoUnload&&parentFrame.CBTData) {
            if(getScore()==SCORE_NONE){nQ=0;setScore(0);}
    		parentFrame.CBTData(strPageNm,nQ,nQA,getScore(),getScore(),(curTime-realStartTime-nSTT),(realStartTime+nSTT),curTime,getBase(location.href)+nextURL);
    	}
	}
}




function GetNotesURL() { return strNotesURL; }

function loadNotes() 
{
	if (isIE2() == true)
	{
	    if (!bDoSpeakerNotes) return;
	    if (parentFrame&&parentFrame.ConfCanLoadNotes) if (!parentFrame.ConfCanLoadNotes()) return;
	    if (bNotesInWindow){
		attr='scrollbars=yes,resizable=yes,';
		if(isNS4)attr+='left='+window.screenX+',top='+(window.screenY+window.outerHeight)+',width='+window.innerWidth+',height=150';
		else attr+='left=0,top=0,width=320,height=240';
		notesW=open(strNotesURL==''?'about:blank':strNotesURL,'SpeakerNotes',attr);
	    }
	    else { if (parentFrame&&parentFrame.NotesLoadFrame) parentFrame.NotesLoadFrame();}
	}
	else
	{
		if (!bDoSpeakerNotes) return;
		if (parentFrame&&parentFrame.ConfCanLoadNotes) if (!parentFrame.ConfCanLoadNotes()) return;
		if (bNotesInWindow)
			{
			attr='scrollbars=yes,resizable=yes,';
			if (browserType=="NN")
				{
				attr+='left='+window.screenX+',top='+(window.screenY+window.outerHeight)+',width='+window.innerWidth+',height=150';
				}
			else 
				{
		    attr+='left=0,top=0,width=320,height=240';
		    }
			notesW=open(strNotesURL==''?'about:blank':strNotesURL,'SpeakerNotes',attr);
			}
		else
			{
			if (parentFrame&&parentFrame.NotesLoadFrame) parentFrame.NotesLoadFrame();
			}
	}
}

function killNotes() { 
    if(bNotesInWindow) {if(notesW&&notesW.close)notesW.close();notesW=null;}
}

function sendConfEvent(n,str1,str2,nP1,nP2,nP3) {
	if (parentFrame&&parentFrame.ConfSendEvent)
		parentFrame.ConfSendEvent(n,str1,str2,nP1,nP2,nP3);
}

function doEvent(n,str1,str2,nP1,nP2,nP3) {
	// make sure n is of integer type
	n=n-0;
    if (n >= 100 && window.doAnnotEvent)
        doAnnotEvent(n,str1,str2,nP1,nP2,nP3);
	else {
    	switch (n) {
    	case 1: evGotoURL(false,str1,str2,nP1); break;
    	case 2: evGotoSlide(false,str1,nP1); break;
    	case 3: evControlObj(false,str1,nP1); break;
    	case 4: evPlayRange(false,str1,str2,nP1,nP2,nP3); break;
    	case 5: evPlayMedia(false,str1,nP1,nP2); break;
    	case 6: evJumpTime(false,nP1,nP2,nP3,str1==""?-1:Number(str1)); break;
    	case 7: evPauseSlide(false,nP1,nP2); break;
    	case 8: evUnpauseSlide(false); break;
    	}
    }
}

function evGotoURL(c,url,target,bFinish) {
	if (c) sendConfEvent(1,url,target,bFinish?1:0,0,0);
	if (bFinish) setNextTmp (url,target);
	else jumpTo(url,target);
}

function evGotoSlide(c,url,bFinish) {
	if (c) sendConfEvent(2,url,'',bFinish?1:0,0,0);
	if (bFinish) setNextTmp (url,"_self");
	else jumpTo(url,"_self");
}

function evControlObj (c,name,nAction) {
	if (c) sendConfEvent(3,name,'',nAction,0,0);
	controlObj ('SCL',name,nAction);
}

function evPlayRange (c,sl1,sl2,bFinish,bRestart,bSameTime) {
	if (c) sendConfEvent(4,sl1,sl2,bFinish?1:0,bRestart?1:0,bSameTime?1:0);
	playRange (sl1,sl2,bRestart,bSameTime,bFinish);
}

function evPlayMedia(c, name, v, bReal) {
	if (c) sendConfEvent(5,name,'',v,bReal?1:0,0);
	playMM('SCL',name,v,bReal);
}

function evJumpTime2(c,t,bFinish,p,o) {
    // Convert from Astound 0-32000 time to timeline index
    evJumpTime(c, (Math.floor((t*nDur/MAXTM+nSTT)/nGTStep))*INDEXMUL, bFinish, p, o);
}

function evJumpTime(c,t,bFinish,p,o) {
	//if (bFinish) 
	if (bFinish != 0)
		setNextTmp ("javascript:jumpToTime("+t+","+p+","+o+");","_self");
	else jumpToTime(t,p,o);
	if (c) sendConfEvent(6,'','',t,bFinish?1:0,p);
}

function evPauseSlide(c,t,cl) {
	pauseSlide(t,cl);
	if (c) sendConfEvent(7,'','',t,cl,0);
}

function evUnpauseSlide(c) {
	unpauseSlide();
	if (c) sendConfEvent(8,'','',0,0,0);
}

function useFrame(fr,url) {
    sToParams(location.search,params);
    setParam(params,"astredirect",url);
    location.href=fr+paramsToS(params);
}

function GetURL() { return location.href}
function GetTime() { return nTimeIndex*INDEXMUL + nRestart; }
function IsPaused() { return bPause?1:0; }


function getOdo() { return nOdo; }
function setOdo(n) { nOdo = n; }

// Pause enumeration ...

var arrPauses = new Array;

function enumPauses()
{
  var strPauses = "";
  for(var i=0;i<arrPauses.length;i++) {
    strPauses += "" + arrPauses[i] + ",";
  }
  return strPauses;
}

//***** SPECIFIC ALT BROWSERS *****

function detectBrowser()
{
// Opera
if (navigator.userAgent.indexOf("Opera")!=-1  && document.getElementById) return"OP"; 

// Internet Explorer IE4 upwards
if (document.all) return "IE"; 

// Netscape version 4
if (document.layers) return "NN"; 

// Mozila e.g. Netscape 6 upwards, Firefox, Safari
if (!document.all && document.getElementById) return "MO"; 
}

function getElement(id, doc)
{
if(doc.getElementById)
	{	
	return doc.getElementById(id);
	}
else if (doc.all)
	{
	return doc.all[id];
	}
else if(doc.layers)
	{
	return doc.layers[id];
	}
return 0;
}

// init function to run only after after domain set
function initVarJump() 
{
browserType=detectBrowser();
styleSupport= (document.all ? 1 : 0);
bReloadOnResize = !isIE4;
document.tls=new Array;
document.tls[0]=new Array;
MainTL = document.tls[0];
MainTL.bActive = true;
pathArray=new Array;
trIn=new Array;
trOut=new Array;
Divs=new Array;
docbtns = new Array;
docbtns.length = 0;
params = new Array;
}

function isFunction(a) 
{
return typeof a == 'function';
}


function isObject(a)
{
return (a && typeof a == 'object') || isFunction(a);
}


function isSafari()
{
if(navigator.userAgent.indexOf("Safari")>-1) return true;
return false;
}

// (C) 2001 Genesys Conferencing.



