<SCRIPT LANGUAGE=VBScript RUNAT=Server>


Public Function setLang(strFrom)

' Variable Declarations
'Dim strFrom
Dim strAcceptLanguage
Dim strLangMajor	' The minor and major parts of the language.  ie. If we have en-us, then
Dim strLangMinor	' the major=en and minor=us
Dim strLangFile
Dim strFileMajor
Dim strFileMajorOverride ' File if there is an override
Dim strFileMajorAndMinor
Dim strFileDefault	' Default is English
Dim nOpenFile		' Should we try to read from the file or not
Dim strHeaderFile
Dim strFooterFile
Dim strPos
Dim fs
Dim objInFile
Dim strIn
Dim ba

Response.write ("-->")

' Get the language of the user's browser
' now we take this value from a query variable
' strAcceptLanguage = Request.ServerVariables("HTTP_ACCEPT_LANGUAGE")
strAcceptLanguage = Request.QueryString("lang")

' Use english if there is no language specified
//if Len(strAcceptLanguage) = 0 Then
if (isEmpty(Request.QueryString("lang"))) Then
	strAcceptLanguage = "en"
End If

' Filter out all but the first language listed
strPos = InStr(1, strAcceptLanguage, ",")


If strPos > 0 Then
   strAcceptLanguage = Left(strAcceptLanguage, strPos - 1)
End If

'Response.write("alert('here' " & strAcceptLanguage & ");")

' Now find the dash ie. en-us.....en is the major language identifier, us is the minor
' However, if there is no dash, it must just be a two character language code
strPos = InStr(1, strAcceptLanguage, "-")
if strPos > 0 Then
	strLangMajor = Left(strAcceptLanguage, strPos - 1)
	strLangMinor = Mid(strAcceptLanguage, strPos + 1, 2)		' We know that language major and minor versions are always 2 characters long
Else
	strLangMajor = strAcceptLanguage
End If
'Response.write("alert('here' " & strLangMajor & ");")
' This file is called with a parameter called from which indicates the file it was called from...This
' lets us find the appropriate language file
'strFrom = Request.QueryString("from")
'strFrom = Request.ServerVariables("HTTP_REFERER")
' If there is no From, try the referrer
if Len(strFrom) = 0 Then
	strFrom = Request.ServerVariables("HTTP_REFERER")
End If

' Find the last slash in the referring address, and take everything after it.
strPos = InStrRev(strFrom, "/")
dim nLen 
nLen = Len(strFrom)

If strPos > 0 Then
  strLangFile = Right(strFrom, nLen - strPos)
Else 
  strLangFile = strFrom
End If

' Find the .html or .htm and remove it
strPos = InStrRev(strLangFile, ".htm")
If strPos < 0 Then
	strPos = InStrRev(strLangFile, ".asp")
End If

If strPos > 0 Then
	strLangFile = Left(strLangFile, strPos - 1)
End If

ba = Request.QueryString("ba")
if Len(ba) = 0 Then
	ba = "-1"
End If

' Now make two strings, one with a major and minor version, and one with just a major version...This will
' Allow us to use minor versions in the future
' Format for the major file is .\major\filename_major.js
' Format for the major and minor file is .\major\minor\filename_major.js

strFileMajorOverride = "\gcc_content\util\overrides\"& ba & "\" & strLangMajor & "\" & strLangFile & "_" & strLangMajor & ".js"
strFileMajor = "\gcc_content\util\" & strLangMajor & "\" & strLangFile & "_" & strLangMajor & ".js"
strFileMajorAndMinor = "\gcc_content\util\" & strLangMajor & "\" & strLangMinor & "\" & strLangFile & "_" & strLangMajor & ".js" 
strFileDefault = "\gcc_content\util\en\" & strLangFile & "_en.js"
strHeaderFile = "\gcc_content\util\lang_header.js"
strFooterFile = "\gcc_content\util\lang_footer.js"

' Create a File System Object
Set fs=Server.CreateObject("Scripting.FileSystemObject")

'Response.write("\n<br>alert('majoroverride' " & strFileMajorOverride & ");")

' Get the header file (it contains script header so that the translators will not 
' translate it, and because, we cannot do a response.write with the script without throwing an error
' actually i cannot even write the word script surrounded by angle brackets in a comment without
' having asp blowup
If (fs.FileExists(Server.Mappath(strHeaderFile)))=true Then
	Set objInFile = fs.OpenTextFile(Server.Mappath(strHeaderFile))
	' Loop Through Real File and Output Results to Browser
	Do While Not objInFile.AtEndOfStream
		strIn = objInFile.ReadLine
		Response.Write strIn & vbCRLF
	Loop

	' Close file and free variables
	objInFile.Close
	Set objInFile = Nothing
Else
	response.write ("A fatal error has occured in language processing.  Cannot continue.")
	response.write("<!-" & "-")
	return 0
End If

' Right now, the file is not Open, so set the variable indicating this
nOpenFile = 0

' Look for the language file
'
' ***************************************
' For now, since we are not supporting minor languages we will comment this out, 
' I think having a failed file open on every hit to every page in the content server 
' will lead to a pretty big performance hit
' If (fs.FileExists(Server.Mappath(strFileMajorAndMinor)))=true Then
' 		Set objInFile = fs.OpenTextFile(Server.Mappath(strFileMajorAndMinor))
'		nOpenFile = 1
'
' Elseif
' ***************************************

If (fs.FileExists(Server.Mappath(strFileMajorOverride)))=true Then
	Set objInFile = fs.OpenTextFile(Server.Mappath(strFileMajorOverride))
	nOpenFile = 1
	
Elseif (fs.FileExists(Server.Mappath(strFileMajor)))=true Then
	Set objInFile = fs.OpenTextFile(Server.Mappath(strFileMajor))
	nOpenFile = 1
	
Elseif (fs.FileExists(Server.Mappath(strFileDefault)))=true Then
	Set objInFile = fs.OpenTextFile(Server.Mappath(strFileDefault))
	nOpenFile = 1
Else
      Response.Write("Error opening language file")
End If

If (nOpenFile = 1) Then

	' Loop Through Real File and Output Results to Browser
	Do While Not objInFile.AtEndOfStream
	strIn = objInFile.ReadLine
	Response.Write strIn & vbCRLF
	Loop

	' Close file and free variables
	objInFile.Close
	Set objInFile = Nothing
	
End If

' Get the footer file (it contains script footer so that the translators will not 
' translate it, and because, we cannot do a response.write with the script without throwing an error
' actually i cannot even write the word script surrounded by angle brackets in a comment without
' having asp blowup
If (fs.FileExists(Server.Mappath(strFooterFile)))=true Then
	Set objInFile = fs.OpenTextFile(Server.Mappath(strFooterFile))
	' Loop Through Real File and Output Results to Browser
	Do While Not objInFile.AtEndOfStream
		strIn = objInFile.ReadLine
		Response.Write strIn & vbCRLF
	Loop

	' Close file and free variables
	objInFile.Close
	Set objInFile = Nothing
Else
	response.write ("A fatal error has occured in language processing.  Cannot continue.")
	response.write("<!-" & "-")
	return 0
End If

set fs=nothing

'asp is soooooo picky...here's a open comment tag with no close comment
response.write("<!-" & "-")

End Function
</script>